SystemOrganization addCategory: #'ECompletion-View'!
SystemOrganization addCategory: #'ECompletion-Squeak'!
SystemOrganization addCategory: #'ECompletion-Model'!
SystemOrganization addCategory: #'ECompletion-Tests'!
SystemOrganization addCategory: #ECompletion!

!Debugger methodsFor: '*ecompletion' stamp: 'bar 12/15/2004 11:55'!
guessTypeForName: aString 
	| index object |
	index := tempNames
				indexOf: aString
				ifAbsent: [].
	object := index
				ifNil: [index _ self receiver class allInstVarNames
						indexOf: aString
						ifAbsent: [].
					self receiver instVarAt: index]
				ifNotNil: [self selectedContext tempAt: index].
	^ object
		ifNil: [self guessTypeForName: aString]
		ifNotNil: [object class]! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 12/16/2004 10:01'!
completionController
	| controller |
	controller _ self triggerEvent: #getCompletionController.
	controller ifNil:[ controller _ self initializeCompletionController ].
	^controller! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 12/16/2004 10:01'!
initializeCompletionController
	| controller |
	controller _ self createCompletionController.
	self
		when: #getCompletionController
		evaluate: (MessageSend receiver: controller selector: #yourself).
	^controller! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 11/30/2004 16:08'!
receiverClass
	^nil! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 12/15/2004 09:30'!
createCompletionController
	^ ECController model: self! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 12/13/2004 16:08'!
guessTypeForName: aString
	^nil! !

Object subclass: #ECTestSuperClass
	instanceVariableNames: 'superInstVar'
	classVariableNames: 'SuperClassVar'
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECTestSuperClass commentStamp: '<historical>' prior: 0!
I'm only for SUnit TestCases.!

!ECTestSuperClass methodsFor: 'as yet unclassified' stamp: 'bar 12/6/2004 08:45'!
toBeOverriden: anArgument 
	15 > 16
		ifTrue: [self sample * anArgument ]! !

!ECTestSuperClass methodsFor: 'as yet unclassified' stamp: 'bar 12/6/2004 08:44'!
testIt: aString
	self subclassResponsibility ! !

ECTestSuperClass subclass: #ECTestClass
	instanceVariableNames: 'third fourth typeSuggestingParameter messageSend messageSend2 typeSuggestingParameter2 complexInit complexInit2 constantInteger constantSymbol constantArray constantBoolean constantString constantNil globalVarKeyword globalVarKeyword2'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECTestClass commentStamp: '<historical>' prior: 0!
I'm only for SUnit TestCases.!

!ECTestClass methodsFor: 'as yet unclassified' stamp: 'bar 12/9/2004 19:40'!
testIt: anArgument 
	| loc1 x2 t |
	x2 := [:bar :var | var < bar].
	loc1 := constantArray.
	x2 value: loc1.
	t := 15.
	^ x2! !

!ECTestClass methodsFor: 'as yet unclassified' stamp: 'bar 12/13/2004 17:29'!
lowPriorityOverrides: aRectangle 
	messageSend := aRectangle.
	typeSuggestingParameter2 := aRectangle. ! !

!ECTestClass methodsFor: 'as yet unclassified' stamp: 'bar 12/13/2004 17:41'!
initialize: aRectangle 
	constantInteger := 15.
	constantString := 'Ruben'.
	constantSymbol := #Symbol.
	constantArray := #(15 16 17 28 ).
	constantBoolean := true.
	typeSuggestingParameter := aRectangle.
	messageSend := Dictionary new.
	messageSend2 := aRectangle origin.
	globalVarKeyword := SortedCollection
				sortBlock: [:a :b | a <= b].
	globalVarKeyword2 := SortedCollection new: 15.
	constantNil := nil.
	typeSuggestingParameter2 := nil.
	complexInit := 15 > 16
				ifTrue: [#Symbol]
				ifFalse: ['String'].
	complexInit2 := Dictionary new: aRectangle origin x. ! !

!ECTestClass class methodsFor: 'as yet unclassified' stamp: 'bar 8/8/2005 10:31'!
initialize
	super initialize.
	ClassVar _ 'Any string'.
! !

!ECTestSuperClass methodsFor: 'as yet unclassified' stamp: 'bar 11/29/2004 15:55'!
initialize
	superInstVar _ Dictionary new.! !

!ECTestSuperClass methodsFor: 'as yet unclassified' stamp: 'bar 12/6/2004 16:19'!
toBeOverridenWithReturn
	^ 'saga'! !

!ECTestSuperClass class methodsFor: 'as yet unclassified' stamp: 'bar 8/8/2005 10:30'!
initialize
	SuperClassVar _ Dictionary new.! !

Object subclass: #ECController
	instanceVariableNames: 'model menuMorph editor context oppositeChar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-View'!

ECController class
	instanceVariableNames: 'initialized smartCharacters'!

!ECController commentStamp: '<historical>' prior: 0!
I live as an instance variable in a Browser, Debugger, Workspace or other window. I'm the glue between all participants of the completion system. I create the ECContext and pass myself to the ECMenuMorph. I process the keyboard events and pass them to the ECMenuMorph or close the morph if needed.!

!ECController methodsFor: 'menu morph' stamp: 'bar 12/20/2004 22:39'!
openMenuFor: aParagraphEditor 
	| theMenu |
	context _ ECContext
				controller: self
				class: model selectedClassOrMetaClass 
				source: aParagraphEditor text string
				position: aParagraphEditor caret - 1.
	editor _ aParagraphEditor.
	theMenu _ ECMenuMorph
				controller: self
				position: (aParagraphEditor selectionPosition: context completionToken).
	theMenu isClosed
		ifFalse: [menuMorph _ theMenu]! !

!ECController methodsFor: 'keyboard' stamp: 'bar 2/25/2006 16:14'!
smartCharInput: aCharacter editor: aParagraphEditor 
	| caret selection pos content |
	(self checkNeedlesCharacter: aCharacter editor: aParagraphEditor) 
		ifTrue: [^true].
	oppositeChar := self class smartCharacters at: aCharacter ifAbsent: [^nil].
	editor := aParagraphEditor.
	caret := editor caret.
	selection := editor selection.
	content := WriteStream on: String new.
	content
		nextPut: aCharacter;
		nextPutAll: selection;
		nextPut: oppositeChar.
	editor zapSelectionWith: content contents.
	pos := caret + 1.
	editor selectAt: pos.
	editor morph invalidRect: editor morph bounds.
	selection ifNotEmpty: [oppositeChar := nil]! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/15/2004 09:23'!
workspace
	^nil! !

!ECController class methodsFor: 'testing' stamp: 'bar 4/11/2005 11:00'!
isEnabled
	initialized
		ifNil: [self initialize].
	^ ECPreferences enabled! !

!ECController class methodsFor: 'instance creation' stamp: 'bar 2/25/2006 15:11'!
smartCharacters
	smartCharacters
		ifNil:[self initializeSmartCharacters].
	^smartCharacters ! !

!ECController methodsFor: 'menu morph' stamp: 'bar 12/13/2004 15:09'!
closeMenu
	menuMorph
		ifNotNil: [menuMorph delete]! !

!ECController class methodsFor: 'instance creation' stamp: 'bar 12/13/2004 12:05'!
model: aStringHolder 
	^self new setModel: aStringHolder! !

!ECController methodsFor: 'initialize-release' stamp: 'bar 12/13/2004 11:02'!
setModel: aStringHolder
	model _ aStringHolder! !

!ECController methodsFor: 'type guessing' stamp: 'bar 12/17/2004 22:42'!
guessTypeFor: aString 
	model
		ifNil: [
			^ nil]
		ifNotNil: [^ model guessTypeForName: aString]! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/13/2004 17:34'!
editor
	^ editor. ! !

ECController subclass: #ECWorkspaceController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-View'!

!ECWorkspaceController commentStamp: '<historical>' prior: 0!
I'm a specialized controller, that works with Workspaces.!

!ECWorkspaceController methodsFor: 'accessing' stamp: 'bar 12/15/2004 09:23'!
workspace
	^model! !

!ECWorkspaceController methodsFor: 'accessing' stamp: 'bar 12/16/2004 11:14'!
additionals
	^ self workspace completionAdditionals! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/16/2004 11:13'!
additionals
	^ nil! !

!ECController class methodsFor: 'initialize class' stamp: 'bar 4/11/2005 10:55'!
initializePreferences
	ECPreferences initialize! !

!ECController methodsFor: 'keyboard' stamp: 'bar 1/6/2005 08:57'!
handleKeystrokeAfter: aKeyboardEvent editor: aParagraphEditor 
	(aParagraphEditor isNil or:[self isMenuOpen not]) ifTrue:[^self].
	self setModel: aParagraphEditor model.
			context narrowWith: aParagraphEditor wordAtCaret.
			menuMorph narrowCompletion! !

!ECController class methodsFor: 'initialize class' stamp: 'bar 2/25/2006 12:40'!
initializeSmartCharacters
	smartCharacters _ Dictionary new.
	smartCharacters 
		at: $( put: $);
		at: $[ put: $];
		at: ${ put: $};
		at: $" put: $";
		at: $' put: $'.! !

!ECController methodsFor: 'keyboard' stamp: 'bar 3/1/2006 14:46'!
handleKeystrokeBefore: aKeyboardEvent editor: aParagraphEditor 
	"I return a boolean. true when I have handled the event and no futher 
	processing 
	is needed by the caller."
	| keyValue controlKeyPressed isSpaceKey |
	self setModel: aParagraphEditor model.
	keyValue _ aKeyboardEvent keyValue.
	controlKeyPressed _ aKeyboardEvent controlKeyPressed.
	isSpaceKey _ #(0 32 ) includes: keyValue.
	"Ctrl-Space or Tab for open"
	self isMenuOpen
		ifFalse: [(isSpaceKey & controlKeyPressed
					or: [keyValue = 9
							and: [aParagraphEditor isCaretBehindChar
									and: [controlKeyPressed not]]])
				ifTrue: [self openMenuFor: aParagraphEditor.
					^ true]
				ifFalse: [(self smartCharInput: keyValue asCharacter editor: aParagraphEditor)
						ifNotNil: [^ true]].
			^ false].
	"Home"
	keyValue = 1
		ifTrue: [menuMorph home.
			^ true].
	"Ctrl-b"
	(keyValue = 2
			and: [controlKeyPressed])
		ifTrue: [menuMorph browse.
			^ true].
	"End"
	(keyValue = 4
			and: [controlKeyPressed not])
		ifTrue: [menuMorph end.
			^ true].
	"Ctrl-d"
	(keyValue = 4
			and: [controlKeyPressed])
		ifTrue: [menuMorph toggleDetail.
			^ true].
	"Arrow up"
	keyValue = 30
		ifTrue: [menuMorph moveUp.
			^ true].
	"Arrow down"
	keyValue = 31
		ifTrue: [menuMorph moveDown.
			^ true].
	"Page up"
	keyValue = 11
		ifTrue: [menuMorph pageUp.
			^ true].
	"Page down"
	keyValue = 12
		ifTrue: [menuMorph pageDown.
			^ true].
	"Tab or Ctrl-Space"
	(keyValue = 13
			or: [isSpaceKey & controlKeyPressed
					or: [keyValue = 9]])
		ifTrue: [menuMorph insertSelected
				ifTrue: [^ true]].
	"Ctrl-u"
	keyValue = 21 & controlKeyPressed
		ifTrue: [menuMorph switchToUntyped.
			^ true].
	"Crtl-t"
	(keyValue = 20
			and: [controlKeyPressed])
		ifTrue: [menuMorph expand.
			^ true].
	"All keys but the alphanumeric chars (without command and control ) 
	and the backspace key do close the menu"
	keyValue = 8
		ifTrue: [aParagraphEditor isCaretBehindChar not
				ifTrue: [self closeMenu].
			^ false].
	(controlKeyPressed not & aKeyboardEvent commandKeyPressed not
			and: [aKeyboardEvent keyCharacter isAlphaNumeric])
		ifFalse: [self closeMenu.
			^ keyValue = 27].
	^ false! !

!ECController methodsFor: 'menu morph' stamp: 'bar 12/13/2004 11:06'!
isMenuOpen
	^menuMorph notNil! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/13/2004 12:08'!
context
	^context! !

!ECController methodsFor: 'keyboard' stamp: 'bar 2/25/2006 16:15'!
checkNeedlesCharacter: aCharacter editor: aParagraphEditor 
	| result |
	oppositeChar	ifNil: [^ false].
	result _ oppositeChar = aCharacter.
	result
		ifTrue: [aParagraphEditor selectAt: aParagraphEditor caret + 1.
			editor morph invalidRect: editor morph bounds].
	oppositeChar _ nil.
	^ result! !

!ECController methodsFor: 'menu morph' stamp: 'bar 12/13/2004 16:39'!
menuClosed
	menuMorph := nil.
	context := nil.
	editor := nil! !

!ECController class methodsFor: 'initialize class' stamp: 'bar 2/25/2006 12:39'!
initialize
	self initializePreferences.
	self initializeSmartCharacters.
	initialized _ true.! !

!ECController class methodsFor: 'testing' stamp: 'bar 2/25/2006 15:34'!
allowModel: aModel 
	^ (self isEnabled 
			and: [aModel notNil])
		and: [(aModel isKindOf: StringHolder)
				or: [aModel isKindOf: (Smalltalk at: #OBDefinitionPanel ifAbsent:[nil])]]! !

Object subclass: #ECEntryDescription
	instanceVariableNames: 'title description label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECEntryDescription class methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:39'!
label: firstString 
	^ self new 
		setLabel: firstString
		title: '(unknown)'
		description: ''! !

!ECEntryDescription class methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:39'!
label: firstString title: secondString description: thirdString 
	^ self new 
		setLabel: firstString
		title: secondString
		description: thirdString! !

!ECEntryDescription methodsFor: 'initialize-release' stamp: 'bar 3/1/2006 15:39'!
setLabel: firstString title: secondString description: thirdString 
	label _ firstString.
	title _ secondString.
	description _ thirdString! !

!ECEntryDescription methodsFor: 'accessing' stamp: 'bar 3/1/2006 15:20'!
description
	^description! !

!ECEntryDescription methodsFor: 'accessing' stamp: 'bar 3/1/2006 15:39'!
label
	^ label! !

!ECEntryDescription methodsFor: 'accessing' stamp: 'bar 3/1/2006 15:20'!
title
^ title! !

!ECEntryDescription methodsFor: 'accessing' stamp: 'bar 3/1/2006 15:44'!
hasType
	^true! !

Object subclass: #ECEntry
	instanceVariableNames: 'contents type description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECEntry commentStamp: 'bar 10/5/2005 23:31' prior: 0!
I represent a completion entry that is management by a ECModel and shown in the ECMenuMorph as a menu entry.!

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 18:56'!
contents
	^contents! !

ECEntry subclass: #ECLocalEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECLocalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:41'!
label
	^ 'local variable'! !

!ECLocalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ (anECContext guessTempVarClass: contents type: type) 
		ifNil: [anECContext guessArgument: contents]! !

!ECLocalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:51'!
isLocal
	^true! !

ECEntry subclass: #ECGlobalEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECGlobalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	| globalEntry |
	globalEntry _ Smalltalk at: contents ifAbsent: [^ nil].
	(globalEntry isKindOf: Behavior) ifTrue: [^ globalEntry].
	globalEntry ifNotNil: [^ globalEntry class].
	^ nil! !

!ECGlobalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:41'!
label
	^ 'global'! !

ECEntry subclass: #ECInstVarEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECInstVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ anECContext guessInstVarClass: contents! !

!ECInstVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:41'!
label
	^ 'instance variable'! !

!ECInstVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:51'!
isInstance
^true! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 16:09'!
browseWith: anECContext 
	type _ self guessTypeWith: anECContext.
	type
		ifNil: [^ false].
	Browser fullOnClass: type.
	^ true! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 18:37'!
descriptionWith: anECContext 
	| |
	description
		ifNotNil: [^ description].
	^description _ self createDescriptionWith: anECContext! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ nil! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/14/2005 21:44'!
completion
	^ self contents asSymbol! !

ECEntry subclass: #ECClassVarEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECClassVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:40'!
label
	^ 'class variable'! !

!ECClassVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ anECContext guessClassVarClass: contents! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 18:55'!
setContents: aString type: aSymbol
	contents _ aString.
	type _ aSymbol! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 19:08'!
printOn: aStream 
	aStream nextPutAll: self class name;
		 nextPut: $(;
		 nextPutAll: contents;
		 nextPut: $,;
		 nextPutAll: type;
		 nextPut: $)! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:50'!
isInstance
	^ false! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 10/5/2005 22:35'!
<= aECEntry 
	^ contents <= aECEntry contents! !

ECEntry subclass: #ECSelectorEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECSelectorEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 18:40'!
createDescriptionWith: anECContext 
	^self
		findMethodWith: anECContext
		do: [:clazz :method | ECEntryDescription
				label: self label
				title: nil
				description: method getSource
			"(SHTextStylerST80 new styledTextFor:"]
		ifAbsent: [:selector | 
			| implementors output | 
			output _ WriteStream on: String new.
			implementors _ self systemNavigation allImplementorsOf: selector.
			implementors
				do: [:each | output nextPutAll: each classSymbol printString;
						 cr].
			ECEntryDescription
				label: self label
				title: 'Implementors'
				description: output contents]! !

!ECSelectorEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:41'!
label
	^ 'selector'! !

!ECSelectorEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ nil! !

!ECSelectorEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 18:21'!
browseWith: anECContext 
	| navigation |
	navigation _ self systemNavigation.
	^ self
		findMethodWith: anECContext
		do: [:clazz :method | 
			navigation browserClass fullOnClass: clazz selector: method selector.
			true]
		ifAbsent: [:selector | navigation browseAllImplementorsOf: selector. true]! !

!ECSelectorEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 18:05'!
findMethodWith: anECContext do: foundBlock ifAbsent: notfoundBlock 
	| theClass method |
	theClass _ anECContext model theClass.
	theClass
		ifNil: [^ notfoundBlock value: contents].
	method _ theClass lookupSelector: contents.
	^ foundBlock value: theClass value: method! !

!ECEntry methodsFor: 'detail information' stamp: 'bar 3/2/2006 18:38'!
createDescriptionWith: anECContext 
	| clazz |
	clazz _ self guessTypeWith: anECContext.
	^ clazz
		ifNil: [ECEntryDescription label: self label]
		ifNotNil: [ECEntryDescription
				label: self label
				title: clazz printString
				description: clazz comment]! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 10/5/2005 22:36'!
contentsAsSymbol
	^ contents asSymbol ! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:40'!
label
	^ 'unknown'! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:51'!
isLocal
	^ false! !

ECEntry subclass: #ECSelfEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECSelfEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ anECContext theClass! !

!ECSelfEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:42'!
label
	^ 'self'! !

ECEntry subclass: #ECSuperEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECSuperEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ anECContext theClass ifNotNil: [anECContext theClass superclass]! !

!ECSuperEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:42'!
label
	^ 'super'! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:51'!
isSelector
	^ false! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 18:56'!
type
	^type! !

!ECEntry class methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 18:55'!
contents: aString type: aSymbol
	^ self new setContents: aString type: aSymbol! !

Object subclass: #ECModel
	instanceVariableNames: 'clazz selectors narrowString entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECModel commentStamp: '<historical>' prior: 0!
I'm an abstract class that stores the entries to be completed.!

!ECModel methodsFor: 'action' stamp: 'bar 12/6/2004 11:53'!
narrowWith: aString
	self subclassResponsibility ! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/6/2004 14:18'!
initializeSelectors 
	self subclassResponsibility ! !

ECModel subclass: #ECTypedModel
	instanceVariableNames: 'expanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECTypedModel commentStamp: '<historical>' prior: 0!
I'm the model for a typed completion, that means when a receiver class is known. I only have selectors. I have an expand toggle: When false I filter out Object and ProtoObject selectors. The default value is true.!

!ECTypedModel methodsFor: 'private' stamp: 'bar 12/6/2004 14:19'!
initializeSelectors
	self initializeSelectorsFor: clazz! !

!ECTypedModel methodsFor: 'action' stamp: 'bar 3/1/2006 15:49'!
theClass
	^clazz! !

!ECTypedModel methodsFor: 'initialize-release' stamp: 'bar 12/6/2004 17:07'!
initialize
	super initialize.
	expanded := true.
! !

!ECTypedModel methodsFor: 'action' stamp: 'bar 3/1/2006 15:50'!
toggleExpand
	expanded _ expanded not.
	self initializeSelectors.
	self narrowWith: narrowString! !

!ECTypedModel methodsFor: 'private' stamp: 'bar 3/1/2006 13:57'!
initializeSelectorsFor: aClass 
	| classes selectorSet size |
	selectors reset.
	classes _ aClass allSuperclasses.
	size _ 600.
	expanded
		ifFalse: [classes remove: Object.
			classes remove: ProtoObject.
			size _ 100].
	selectorSet _ Set new: size.
	classes add: aClass.
	classes
		do: [:eachClass | eachClass methodDictionary
				keysDo: [:each | each notEmpty
						ifTrue: [selectorSet add: each]]].
	selectorSet _ selectorSet
				collect: [:each | ECSelectorEntry contents: each type: #selector].
	selectors addAll: selectorSet! !

!ECTypedModel methodsFor: 'action' stamp: 'bar 8/13/2005 18:13'!
narrowWith: aString 
	self narrowString: aString.
	entries reset.
	self addToEntries: selectors! !

ECTypedModel subclass: #ECOverrideModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECOverrideModel commentStamp: '<historical>' prior: 0!
I'm used when completing a method override. I contain all selectors of the superclass minus the already implemented selectors of the current class. When a completion occurs I complete a method template with a send to super.!

!ECOverrideModel methodsFor: 'action' stamp: 'bar 12/6/2004 16:52'!
completionAt: aNumber 
	| output source declaration |
	source := self methodSourceAt: aNumber.
	declaration := (source lineCorrespondingToIndex: 1) withoutTrailingBlanks.
	output := WriteStream on: String new.
	output nextPutAll: declaration;
		 cr;
		 tab;
		
		 nextPutAll: (self computeReturn: source);
		 nextPutAll: 'super ';
		 nextPutAll: declaration.
	^ output contents! !

!ECOverrideModel methodsFor: 'action' stamp: 'bar 12/6/2004 15:02'!
title
	^ '(override) ' , clazz superclass name! !

!ECOverrideModel methodsFor: 'private' stamp: 'bar 12/6/2004 16:51'!
computeReturn: aString
	| lastLine |
	lastLine := aString lineCorrespondingToIndex: aString size.
	^(lastLine
				detect: [:each | each = $^]
				ifNone: [])
				ifNil: ['']
				ifNotNil: ['^'].
! !

!ECOverrideModel methodsFor: 'initialize-release' stamp: 'bar 10/5/2005 23:24'!
initializeSelectors
	self initializeSelectorsFor: clazz superclass.
	clazz methodDictionary
		keysDo: [:each | 
			| entry | 
			entry _ selectors
						detect: [:ea | ea contentsAsSymbol == each]
						ifNone: [].
			entry notNil
				ifTrue: [selectors
						remove: entry
						ifAbsent: []]]! !

!ECOverrideModel methodsFor: 'private' stamp: 'bar 10/5/2005 22:36'!
methodSourceAt: aNumber 
	| method classes selector source methods |
	selector _ (self at: aNumber) contentsAsSymbol.
	classes _ clazz allSuperclasses.
	methods _ classes
				collect: [:eachClass | eachClass methodDictionary
						at: selector
						ifAbsent: []].
	methods _ methods
				select: [:each | each notNil].
	method _ methods first.
	source _ method getSourceFromFile asString.
	^ source! !

!ECTypedModel methodsFor: 'action' stamp: 'bar 12/6/2004 14:44'!
title
	^clazz name! !

!ECModel methodsFor: 'private' stamp: 'bar 4/11/2005 11:35'!
resetEntries
	entries _ OrderedCollection new.! !

!ECModel methodsFor: 'testing' stamp: 'bar 12/4/2004 17:24'!
isEmpty
	^entries isEmpty ! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/17/2004 22:45'!
hasMessage
	^ self message notNil! !

ECModel subclass: #ECUntypedModel
	instanceVariableNames: 'instVars localVars includeVariables includeSelectors classVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECUntypedModel commentStamp: '<historical>' prior: 0!
When no receiver class is known, I'm the right model. I store all temporary variables, instance variables of the selected class and all selectors in system. For performance reasons I only collect selectors when at least one character is known.!

!ECUntypedModel methodsFor: 'private' stamp: 'bar 3/1/2006 13:57'!
initializeSelectors
	self resetSelectors.
	includeSelectors
		ifFalse: [Smalltalk
				keysDo: [:each | selectors
						add: (ECGlobalEntry contents: each type: #globalVar)].
			^ self].
	narrowString
		ifEmpty: [^ self].
	ECSymbols
		startsWith: narrowString first
		caseSensitive: ECPreferences caseSensitive
		do: [:each | (includeVariables
					or: [each first isLowercase])
				ifTrue: [selectors
						add: (ECSelectorEntry contents: each type: #selector)]]! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'bar 8/8/2005 10:38'!
setClass: aClass temporaries: aCollection additionals: additionalCollection variables: variablesBoolean selectors: selectorsBoolean 
	includeVariables _ variablesBoolean.
	includeSelectors _ selectorsBoolean.
	clazz _ aClass.
	self initializeInstVars.
	self initializeClassVars.
	includeVariables
		ifTrue: [localVars _ aCollection.
			self addAdditionals: additionalCollection]
		ifFalse: [localVars _ OrderedCollection new].
	self narrowWith: ''! !

!ECUntypedModel methodsFor: 'private' stamp: 'bar 8/13/2005 18:14'!
addSelectors
	selectors
		ifEmpty: [self initializeSelectors].
	self addToEntries: selectors! !

!ECUntypedModel methodsFor: 'private' stamp: 'bar 10/5/2005 23:05'!
addVariables
	includeVariables
		ifFalse: [^ self].
	self addToEntries: localVars.
	self addToEntries: instVars.
	self addToEntries: classVars! !

!ECUntypedModel methodsFor: 'action' stamp: 'bar 4/11/2005 11:35'!
narrowWith: aString 
	self narrowString: aString.
	self resetEntries.
	self addVariables.
	self addSelectors! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'bar 4/11/2005 11:42'!
narrowString: aString 
	(narrowString isEmpty
			or: [aString isEmpty
			or: [aString first ~= narrowString first]])
		ifTrue: [self reset].
	super narrowString: aString! !

!ECUntypedModel methodsFor: 'private' stamp: 'bar 8/14/2005 21:50'!
addAdditionals: aCollection 
	aCollection
		ifNotNil: [aCollection
				do: [:each | | type | each isLocal
						ifTrue: [localVars add: each value]
						ifFalse: [each isInstance
								ifTrue: [instVars add: each value]
								ifFalse: [each isSelector
										ifTrue: [selectors add: each value]]]]]! !

!ECUntypedModel methodsFor: 'accessing' stamp: 'bar 12/20/2004 22:18'!
message
	^ (includeSelectors and:[narrowString isEmpty])
		ifTrue: ['press key for selectors']
		ifFalse: [super message]! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'bar 3/1/2006 13:58'!
initializeClassVars
	(clazz isNil
			or: [includeVariables not])
		ifTrue: [^ self].
	classVars _ clazz allClassVarNames asSortedCollection.
	classVars _ classVars
				collect: [:each | ECClassVarEntry contents: each type: #classVar]! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'bar 8/8/2005 10:41'!
initialize
	super initialize.
	localVars _ SortedCollection new.
	instVars _ SortedCollection new.
	classVars _ SortedCollection new.
	includeSelectors _ true.
	includeVariables _ true! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'bar 3/1/2006 13:26'!
initializeInstVars
	(clazz isNil
			or: [includeVariables not])
		ifTrue: [^ self].
	instVars _ clazz allInstVarNames asSortedCollection.
	instVars _ instVars
				collect: [:each | ECInstVarEntry contents: each type: #instVar].
	instVars
		add: (ECSelfEntry contents: 'self' type: #self).
	instVars
		add: (ECSuperEntry contents: 'super' type: #super)! !

!ECUntypedModel class methodsFor: 'instance creation' stamp: 'bar 4/11/2005 11:33'!
class: aClass temporaries: aCollection additionals: additionalCollection variables: variablesBoolean selectors: selectorsBoolean 
	| newInstance |
	newInstance _ self basicNew initialize.
	newInstance
		setClass: aClass
		temporaries: aCollection
		additionals: additionalCollection
		variables: variablesBoolean
		selectors: selectorsBoolean.
	^ newInstance! !

!ECUntypedModel class methodsFor: 'instance creation' stamp: 'bar 12/20/2004 09:02'!
class: aClass temporaries: aCollection 
	^self 
		class: aClass
		temporaries: aCollection
		additionals: #()
		variables: true
		selectors: true! !

!ECModel methodsFor: 'private' stamp: 'bar 8/14/2005 21:43'!
addToEntries: aCollection 
	| temp caseSensitive |
	caseSensitive _ ECPreferences caseSensitive.
	temp _ aCollection
				select: [:each | each contents beginsWithEmpty: narrowString caseSensitive: caseSensitive].
	entries addAll: temp! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/4/2004 17:21'!
at: aNumber 
	^ entries at: aNumber ! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/4/2004 17:20'!
entries
	^entries! !

!ECModel methodsFor: 'private' stamp: 'bar 4/11/2005 11:51'!
resetSelectors
	selectors _ SortedCollection new: 500.! !

!ECModel methodsFor: 'accessing' stamp: 'bar 10/5/2005 22:53'!
entriesOfType: aSymbol 
	| collection |
	collection _ entries
				select: [:each | each type == aSymbol].
	^ collection
		collect: [:each | each contents]! !

!ECModel methodsFor: 'private' stamp: 'bar 4/11/2005 11:50'!
reset
	self resetSelectors.
	self resetEntries.
	narrowString _ String new! !

!ECModel methodsFor: 'initialize-release' stamp: 'bar 4/11/2005 11:22'!
initialize
	self reset! !

!ECModel methodsFor: 'action' stamp: 'bar 12/6/2004 14:44'!
title
	^nil! !

!ECModel methodsFor: 'private' stamp: 'bar 12/4/2004 17:40'!
narrowString: aString 
	narrowString := aString! !

!ECModel methodsFor: 'action' stamp: 'bar 3/1/2006 15:48'!
theClass
	^nil! !

!ECModel methodsFor: 'initialize-release' stamp: 'bar 1/6/2005 08:54'!
setClass: aClass 
	clazz := aClass.
	self initializeSelectors.
	self narrowWith: String new! !

!ECModel methodsFor: 'testing' stamp: 'bar 12/4/2004 17:22'!
notEmpty 
	^self isEmpty not! !

!ECModel methodsFor: 'action' stamp: 'bar 8/14/2005 21:43'!
completionAt: aNumber 
	^ (self at: aNumber) completion separateKeywords , ' '! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/4/2004 17:21'!
entryCount
	^entries size! !

!ECModel methodsFor: 'accessing' stamp: 'bar 1/6/2005 08:25'!
message
	^self isEmpty ifTrue: ['no completions found'] ifFalse: [nil]! !

!ECModel methodsFor: 'initialize-release' stamp: 'bar 12/5/2004 23:17'!
toggleExpand
	! !

!ECModel class methodsFor: 'instance creation' stamp: 'bar 4/11/2005 11:32'!
class: aClass 
	| newInstance |
	newInstance _ self basicNew initialize.
	newInstance setClass: aClass.
	^ newInstance! !

Object subclass: #ECTypeInfo
	instanceVariableNames: 'type kind temporaryOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECTypeInfo commentStamp: '<historical>' prior: 0!
I'm used in ECInstVarTypeGuesser to store found type informations.!

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:47'!
isDefinedByMessageSend
	^kind == 2! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:02'!
temporaryOffset
	^temporaryOffset! !

!ECTypeInfo class methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:52'!
definedByMessageSend: aClass 
	| newInstance |
	newInstance := self new.
	newInstance setType: aClass kind: 2.
	^ newInstance! !

!ECTypeInfo class methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:52'!
definedByLiteral: aClass 
	| newInstance |
	newInstance := self new.
	newInstance setType: aClass kind: 1.
	^ newInstance! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:47'!
isDefinedByTemporary
	^ kind == 3! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:02'!
temporaryOffset: anInteger
	temporaryOffset _ anInteger ! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:59'!
type: aClass
	type _ aClass! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:01'!
priority
	^kind! !

!ECTypeInfo class methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:02'!
definedByTemporaryVar: anInteger
	| newInstance |
	newInstance := self new.
	newInstance setType: nil kind: 3.
	newInstance temporaryOffset: anInteger.
	^ newInstance! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:01'!
setType: aClass kind: anInteger 
	type := aClass.
	kind := anInteger! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:44'!
type
	^type! !

Object subclass: #ECContext
	instanceVariableNames: 'source position theClass ranges completionIndex recurseCount receiverClass completionToken model controller variables selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

ECContext class
	instanceVariableNames: 'constantTypes'!

!ECContext commentStamp: '<historical>' prior: 0!
A completion is started by the ECController. The controller creates me to compute the context of the completion. The most important information about the context are the receiverClass and the completionToken. I create a ECModel or subclass when requested by the 'model' method.

I use SHParser and SHRange to parse the text input.!

!ECContext methodsFor: 'private-receiver-guessing' stamp: 'bar 3/2/2006 21:29'!
isVariablesOnly
	| current previous |
	current _ ranges at: completionIndex.
	^ current isVariablesOnly
		or: [current isOpening
				or: [previous _ ranges at: completionIndex - 1.
					previous isOpening
						or: [previous isSeparator
								or: [previous isKeyword
										or: [previous isAssignment or:[previous isBinary ]]]]]]! !

!ECContext methodsFor: 'private-compute-index' stamp: 'bar 1/6/2005 22:06'!
checkForZeroPosition
	^ (position = 0
			or: [ranges isEmpty])
		and: [self insertEmptyRangeAt: 1 start: 0 end: 1.
			true]! !

!ECContext methodsFor: 'private-temporaries' stamp: 'bar 1/6/2005 22:36'!
handleBlockStack: aCollection with: aSHRange 
	| range blockStack |
	range _ aSHRange.
	blockStack _ aCollection.
	range isBlockStart
		ifTrue: [blockStack add: OrderedCollection new]
		ifFalse: [range isBlockEnd
				ifTrue: [blockStack removeLast]]! !

!ECContext methodsFor: 'private-receiver-guessing' stamp: 'bar 1/9/2005 14:55'!
checkImpossibleReceiver
	^ self isSelectorsAndVariables
		ifTrue: [self configureSelectorsAndVariables]
		ifFalse: [self isVariablesOnly
				ifTrue: [self configureVariablesOnly]
				ifFalse: [self isSelectorsOnly
						and: [self configureSelectorsOnly]]]. ! !

!ECContext methodsFor: 'accessing' stamp: 'bar 2/26/2006 09:04'!
theClass
	^theClass! !

!ECContext methodsFor: 'accessing' stamp: 'bar 12/21/2004 08:38'!
createModel
	self receiverClass
		ifNotNil: [^ ECTypedModel class: receiverClass].
	(controller workspace isNil
		and: [theClass notNil])
		ifTrue: [completionIndex = 1
				ifTrue: [^ ECOverrideModel class: theClass]].
	^ ECUntypedModel
		class: theClass
		temporaries: self temporaries
		additionals: controller additionals
		variables: variables
		selectors: selectors! !

!ECContext methodsFor: 'private-type-guessing' stamp: 'bar 1/9/2005 13:32'!
guessArgument: aSHRange 
	^ ECInstVarTypeGuesser
		getClassFromTypeSuggestingName: (self sourceOf: aSHRange)! !

!ECContext methodsFor: 'private-temporaries' stamp: 'bar 1/6/2005 22:36'!
convertBlocksToVariables: anOrderedCollection 
	| result blockStack |
	blockStack _ anOrderedCollection.
	result _ OrderedCollection new.
	blockStack
		do: [:each | result addAll: each].
	^ result! !

!ECContext methodsFor: 'private-configure' stamp: 'bar 1/9/2005 11:35'!
configureSelectorsAndVariables
	variables := true.
	selectors := true.
	^true! !

!ECContext methodsFor: 'private-compute-index' stamp: 'bar 1/6/2005 22:04'!
insertEmptyRangeAt: index start: start end: end 
	ranges
		add: (SHRange
				start: start
				end: end
				type: #empty)
		beforeIndex: index! !

!ECContext methodsFor: 'private-temporaries' stamp: 'bar 1/6/2005 22:33'!
blockTemporaries
	| blocks range vars |
	blocks _ OrderedCollection new.
	1
		to: completionIndex - 1
		do: [:index | 
			range _ ranges at: index.
			self handleBlockStack: blocks with: range.
				range isBlockTemporary
						ifTrue: [vars _ blocks last.
							vars add: range]].
	^ self convertBlocksToVariables: blocks! !

!ECContext methodsFor: 'action' stamp: 'bar 12/20/2004 23:16'!
narrowWith: aString 
	completionToken _ aString.
	model ifNotNil:[ model narrowWith: aString ].! !

!ECContext methodsFor: 'private-compute-index' stamp: 'bar 1/6/2005 22:15'!
createEmptyRangeForGapAt: index 
	| current previous |
	current _ ranges at: index.
	previous _ ranges at: index - 1.
	self
		insertEmptyRangeAt: index
		start: previous end + 1
		end: current start - 1.
	^index! !

!ECContext methodsFor: 'accessing' stamp: 'bar 12/18/2004 23:56'!
completionToken
	completionToken
		ifNil: [| range | 
			range _ ranges at: completionIndex.
			completionToken _ self sourceOf: range stopAt: position.
			completionToken _ completionToken wordBefore: completionToken size].
	^ completionToken! !

!ECContext methodsFor: 'private' stamp: 'bar 3/1/2006 13:52'!
guessTempVarClass: aSHRange 
	^self guessTempVarClass: (self sourceOf: aSHRange) type: aSHRange type.
! !

!ECContext methodsFor: 'accessing' stamp: 'bar 3/1/2006 13:43'!
temporaries
	| tempRanges |
	tempRanges _ ranges
				select: [:each | #(#patternTempVar #patternArg ) includes: each type].
	tempRanges addAll: self blockTemporaries.
	^ tempRanges
		collect: [:each | ECLocalEntry
				contents: (self sourceOf: each)
				type: each type]! !

!ECContext methodsFor: 'private-receiver-guessing' stamp: 'bar 1/9/2005 11:33'!
isSelectorsOnly
	| previous |
	previous := ranges at: completionIndex - 1.
	^previous isOpening! !

!ECContext methodsFor: 'private' stamp: 'bar 3/1/2006 13:53'!
guessTempVarClass: aString type: aSymbol 
	| current type varName varType sourceIndex aClass |
	aClass _ controller
				guessTypeFor: aString.
	aClass
		ifNotNil: [^ aClass].
	varName _ aString.
	varType _ aSymbol.
	1
		to: completionIndex
		do: [:index | 
			current _ ranges at: index.
			(current type = varType
					and: [(self sourceOf: current)
								= varName
							and: [index + 3 <= ranges size]])
				ifTrue: [(sourceIndex _ self findSourceRangeFor: index) notNil
						ifTrue: [type _ self guessTypeOf: sourceIndex.
							type
								ifNotNil: [^ type]]]].
	^ nil! !

!ECContext methodsFor: 'private' stamp: 'bar 12/18/2004 23:55'!
sourceOf: aSHRange stopAt: aNumber
	^ aSHRange type = #empty
		ifTrue: [String new]
		ifFalse: [source copyFrom: aSHRange start to: aNumber]! !

!ECContext methodsFor: 'private' stamp: 'bar 1/9/2005 11:35'!
computeReceiverClass
	| previous found |
	recurseCount := 0.
	completionIndex = 1 ifTrue: [^nil].
	found := self checkImpossibleReceiver.
	found ifTrue: [^nil].
	previous := ranges at: completionIndex - 1.
	previous type = #cascadeSeparator 
		ifTrue: [^self guessCascadeReceiver: completionIndex - 1].
	(previous type = #unary 
		and: [(self sourceOf: previous) = 'new' and: [completionIndex > 2]]) 
			ifTrue: 
				[previous := ranges at: completionIndex - 2.
				previous type = #globalVar 
					ifTrue: [^self guessTypeOf: completionIndex - 2]
					ifFalse: 
						[self configureSelectorsOnly.
						^nil]].
	^self guessTypeOf: completionIndex - 1! !

!ECContext methodsFor: 'private' stamp: 'bar 3/1/2006 13:25'!
sourceOf: aSHRange 
	^aSHRange isString
		ifTrue: [aSHRange]
		ifFalse: [self sourceOf: aSHRange stopAt: aSHRange end]! !

!ECContext methodsFor: 'private' stamp: 'bar 8/9/2005 23:36'!
guessInstVarClass: aSHRange 
	| aClass name |
	name _ self sourceOf: aSHRange.
	aClass _ controller guessTypeFor: name.
	aClass
		ifNotNil: [^ aClass].
	^ (ECInstVarTypeGuesser variableName: name class: theClass) perform! !

!ECContext methodsFor: 'action' stamp: 'bar 1/9/2005 11:35'!
switchToUntyped
	receiverClass := nil.
	self configureSelectorsAndVariables.
	model := self createModel! !

!ECContext class methodsFor: 'instance creation' stamp: 'bar 4/11/2005 11:23'!
controller: aECController class: aClass source: aString position: anInteger 
	^ self basicNew initialize
		setController: aECController
		class: aClass
		source: aString
		position: anInteger! !

!ECContext methodsFor: 'private' stamp: 'bar 1/6/2005 13:06'!
guessCascadeReceiver: aNumber 
	| type |
	aNumber to: 1 by: -1 do:[ :index |
	type _ (ranges at: index) type.
			((#(#statementSeparator #assignment #ansiAssignment ) includes: type)
					or: [(type beginsWith: 'pattern')
							or: [type beginsWith: 'methodTemp']])
				ifTrue: [^ self guessTypeOf: index + 1]].
	^ nil! !

!ECContext methodsFor: 'initialize-release' stamp: 'bar 1/6/2005 14:37'!
setController: aECController class: aClass source: aString position: anInteger 
	controller _ aECController.
	theClass _ aClass.
	source _ aString.
	position _ anInteger.
	self createRanges.
	self compute! !

!ECContext methodsFor: 'private-receiver-guessing' stamp: 'bar 1/9/2005 11:33'!
isSelectorsAndVariables
	| current |
	current := ranges at: completionIndex.
	^current isUnfinished! !

!ECContext methodsFor: 'private-configure' stamp: 'bar 1/9/2005 11:35'!
configureSelectorsOnly
	variables := false.
	selectors := true.
	^true! !

!ECContext methodsFor: 'private' stamp: 'bar 1/6/2005 14:37'!
compute
	completionIndex _ self computeIndexOfPosition.
	receiverClass _ self computeReceiverClass! !

!ECContext methodsFor: 'private' stamp: 'bar 8/9/2005 23:32'!
guessClassVarClass: aSHRange 
	| aClass name |
	name _ self sourceOf: aSHRange.
	aClass _ controller guessTypeFor: name.
	aClass
		ifNotNil: [^ aClass].
	^ (ECClassVarTypeGuesser variableName: name class: theClass class) perform! !

!ECContext methodsFor: 'private-compute-index' stamp: 'bar 1/6/2005 22:14'!
createEmptyRangeAtTail
	| previous |
	previous _ ranges last.
	ranges
		add: (SHRange
				start: previous end + 1
				end: source size
				type: #empty).
	^ ranges size! !

!ECContext methodsFor: 'initialize-release' stamp: 'bar 12/20/2004 23:18'!
initialize
	super initialize.
	source _ String new.
	position _ 0.
	recurseCount _ 0.
	variables _ true.
	selectors _ true.
	ranges _ OrderedCollection new.
	completionIndex _ 0.
	completionToken _ nil.! !

!ECContext methodsFor: 'private-type-guessing' stamp: 'bar 8/9/2005 23:03'!
guessTypeOf: aNumber 
	| range |
	self configureSelectorsOnly.
	recurseCount > 10
		ifTrue: [^ nil].
	recurseCount _ recurseCount + 1.
	range _ ranges at: aNumber.
	^ range isSelf
		ifTrue: [theClass]
		ifFalse: [range isSuper
				ifTrue: [theClass superclass]
				ifFalse: [range isConstant
						ifTrue: [range asType]
						ifFalse: [range isArgument
								ifTrue: [self guessArgument: range]
								ifFalse: [range isTemporaryVariable
										ifTrue: [self guessTempVarClass: range]
										ifFalse: [range isInstanceVariable
												ifTrue: [self guessInstVarClass: range]
												ifFalse: [range isClassVariable
														ifTrue: [self guessClassVarClass: range]
														ifFalse: [range isGlobal
																ifTrue: [self guessGlobal: aNumber]]]]]]]]! !

!ECContext methodsFor: 'accessing' stamp: 'bar 12/13/2004 12:01'!
model
	model isNil ifTrue:[ model _ self createModel].
	^model! !

!ECContext methodsFor: 'private' stamp: 'bar 12/13/2004 15:32'!
receiverClass
	^ receiverClass! !

!ECContext methodsFor: 'private-compute-index' stamp: 'bar 1/6/2005 22:14'!
computeIndexOfPosition
	| current |
	self checkForZeroPosition
		ifTrue: [^ 1].
	1
		to: ranges size
		do: [:index | 
			current _ ranges at: index.
			(current includesPosition: position)
				ifTrue: [^ index]
				ifFalse: [current end > position
						ifTrue: [^self createEmptyRangeForGapAt: index
							]]].
	^ self createEmptyRangeAtTail! !

!ECContext methodsFor: 'private' stamp: 'bar 1/9/2005 14:51'!
findSourceRangeFor: aNumber 
	aNumber
		to: ranges size
		by: 2
		do: [:index | 
			index + 3 > ranges size
				ifTrue: [^ nil].
			(ranges at: index + 1) isAssignment
				ifTrue: [(ranges at: index + 3) type = #statementSeparator
						ifTrue: [^ index + 2]
						ifFalse: [(ranges at: index + 2) type = #globalVar
								ifTrue: [^ index + 2]
								ifFalse: [(ranges at: index + 1) isAssignment 
										ifFalse: [^ nil]]]]]! !

!ECContext methodsFor: 'private-configure' stamp: 'bar 1/9/2005 11:34'!
configureVariablesOnly
	variables := true.
	selectors := false.
	^true! !

!ECContext methodsFor: 'private' stamp: 'bar 1/6/2005 14:35'!
createRanges
	| parser |
	parser := SHParserST80 new.
	ranges := parser 
				rangesIn: source
				classOrMetaClass: theClass
				workspace: controller workspace
				environment: nil.
	ranges := ranges select: [:each | each type ~= #comment]! !

!ECContext methodsFor: 'private-type-guessing' stamp: 'bar 1/9/2005 13:33'!
guessGlobal: aNumber 
	| aClass |
	aClass _ Smalltalk
				at: (self
						sourceOf: (ranges at: aNumber)) asSymbol
				ifAbsent: [^ nil].
	aClass isBehavior
		ifFalse: [^ nil].
	aNumber = (completionIndex - 1)
		ifTrue: [^ aClass class].
	(ranges size >= (aNumber + 1)
			and: [(ranges at: aNumber + 1) type = #statementSeparator])
		ifTrue: [^ aClass class].
	^ aClass! !

Object subclass: #ECPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Squeak'!

!ECPreferences class methodsFor: 'as yet unclassified' stamp: 'bar 4/11/2005 10:55'!
initialize
	(Preferences preferenceAt: #ecompletionEnabled)
		ifNil: [Preferences
				addPreference: #ecompletionEnabled
				categories: #(#browsing )
				default: true
				balloonHelp: 'Enable, or disable eCompletion - a completion system that works in a workspace, browser and debugger.'].
	(Preferences preferenceAt: #ecompletionCaseSensitive)
		ifNil: [Preferences
				addPreference: #ecompletionCaseSensitive
				categories: #(#browsing )
				default: true
				balloonHelp: 'decide if you want eCompletion to be case sensitive or not.']! !

!ECPreferences class methodsFor: 'as yet unclassified' stamp: 'bar 4/11/2005 10:54'!
enabled
	^Preferences ecompletionEnabled ! !

!ECPreferences class methodsFor: 'as yet unclassified' stamp: 'bar 4/11/2005 10:58'!
setCaseSensitiveness: aBoolean 
	Preferences setPreference: #ecompletionCaseSensitive toValue: aBoolean! !

!ECPreferences class methodsFor: 'as yet unclassified' stamp: 'bar 4/11/2005 10:54'!
caseSensitive
	^ Preferences ecompletionCaseSensitive ! !

Object subclass: #ECSymbols
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Squeak'!

!ECSymbols class methodsFor: 'as yet unclassified' stamp: 'bar 4/11/2005 16:24'!
startsWith: aChar caseSensitive: aBoolean do: aBlock 
	| char caseInSensitive firstChar |
	caseInSensitive _ aBoolean not.
	firstChar _ caseInSensitive
				ifTrue: [aChar asLowercase]
				ifFalse: [aChar].
	Symbol
		allSymbolTablesDo: [:each | 
			| size | 
			size _ each size.
			char _ size > 0
						ifTrue: [each first].
			(char notNil
					and: [char == firstChar
							or: [caseInSensitive
									and: [char asLowercase == firstChar]]]
					and: [(each findAnySubStr: '- ' startingAt: 2)
							> size])
				ifTrue: [aBlock value: each]]! !

!Workspace methodsFor: '*ecompletion' stamp: 'bar 3/1/2006 13:44'!
completionAdditionals
	| additionals |
	additionals _ SortedCollection new.
	bindings
		ifNotNil: [bindings
				keysDo: [:each | additionals
						add: (ECLocalEntry contents: each type: #local)]].
	^ additionals! !

!Workspace methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 10:14'!
addSymbols: aCollection
	super addSymbols: aCollection.
	bindings 
		ifNotNil:[bindings keysDo:[ :each | aCollection add: #local -> each ]].

! !

!Workspace methodsFor: '*ecompletion' stamp: 'bar 12/16/2004 11:26'!
hasBindingThatBeginsWith: aString
	^false! !

!Workspace methodsFor: '*ecompletion' stamp: 'bar 12/16/2004 11:24'!
guessTypeForName: aString 
	| binding |
	bindings
		ifNotNil: [binding _ bindings
						at: aString
						ifAbsent: [].
			binding
				ifNotNil: [^ binding class]].
	^ super guessTypeForName: aString! !

!Workspace methodsFor: '*ecompletion' stamp: 'bar 12/15/2004 09:30'!
createCompletionController
	^ECWorkspaceController model: self! !

!Workspace methodsFor: '*ecompletion' stamp: 'bar 12/16/2004 11:24'!
hasBindingOf: aString 
	^(self guessTypeForName: aString) notNil! !

!TextMorph methodsFor: '*ecompletion-override' stamp: 'bar 12/18/2004 08:41'!
initialize
	super initialize.
	borderWidth _ 0.
	textStyle _ TextStyle default copy.
	wrapFlag _ true! !

!TextMorph methodsFor: '*ecompletion-override' stamp: 'bar 12/16/2004 19:40'!
keyStroke: evt 
	"Handle a keystroke event."

	| action completionAllowed stringHolder |
	stringHolder := editor model.
	completionAllowed := ECController allowModel: stringHolder.
	completionAllowed 
		ifTrue: 
			[(stringHolder completionController handleKeystrokeBefore: evt
				editor: editor) ifTrue: [^self]].
	evt keyValue = 13 
		ifTrue: 
			[action := self crAction.
			action ifNotNil: 
					["Note: Code below assumes that this was some  
					input field reacting on CR. Break the keyboard  
					focus so that the receiver can be safely deleted."

					evt hand newKeyboardFocus: nil.
					^action value]].
	self handleInteraction: [editor readKeyboard] fromEvent: evt.
	self updateFromParagraph.
	super keyStroke: evt.
	"sends to keyStroke event handler, if any"
	"Narrow the completion with any of the keys"
	completionAllowed 
		ifTrue: 
			[stringHolder completionController handleKeystrokeAfter: evt editor: editor]! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:14'!
isArgument
	^ type = #methodArg! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/6/2005 22:22'!
isBlockEnd
	^ type beginsWith: 'blockEnd'! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:05'!
isSelf
	^type = #self! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:03'!
isTemporaryVariable
	^ #(#tempVar #blockTempVar workspaceVar ) includes: type! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/6/2005 13:18'!
isUnfinished
	^#(#unfinishedString #unfinishedComment ) includes: type! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 14:37'!
isSeparator
	^ #(#methodTempBar #statementSeparator #patternUnary #patternArg #blockPatternArg #blockArgsBar #return #primitiveOrExternalCallEnd) includes: type! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 3/2/2006 21:26'!
isVariablesOnly
	^ self isAssignment
		or: [self isVariable
				or: [self isConstant
						or: [self isSeparator or:[self isBinary]]]]! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:20'!
asType
	type = #symbol
		ifTrue: [^ Symbol].
	type = #character
		ifTrue: [^ Character].
	type = #string
		ifTrue: [^ String].
	type = #number
		ifTrue: [^ Number].
	type = #true
		ifTrue: [^ Smalltalk at: #True].
	type = #false
		ifTrue: [^ Smalltalk at: #False].
	type = #arrayEnd
		ifTrue: [^ Array].
	self isBlockEnd
		ifTrue: [^ BlockContext].
	^ nil! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:20'!
isConstant
	^ self isBlockEnd
		or: [#(#false #true #string #number #symbol #character #arrayEnd ) includes: type]! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/6/2005 13:17'!
isComment
	^ type == #comment! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:13'!
isInstanceVariable
	^ type = #instVar! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/6/2005 13:56'!
isOpening
^ ((type beginsWith: 'blockStart')
			or: [type beginsWith: 'leftParenthesis'])
		! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/6/2005 22:21'!
isBlockStart
	^type beginsWith: 'blockStart'! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/6/2005 22:23'!
isBlockTemporary
	^#(##blockPatternTempVar #blockPatternArg) includes: type! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 3/2/2006 21:27'!
isBinary
	^type == #binary! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:06'!
isGlobal
	^type = #globalVar! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/6/2005 22:08'!
includesPosition: aNumber
^(start <= aNumber
					and: [end >= aNumber])! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 8/9/2005 23:04'!
isClassVariable
	^ type = #classVar! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:13'!
isVariable
	^ self isTemporaryVariable
		or: [self isInstanceVariable
				or: [self isSelf or:[self isSuper]]]! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 13:05'!
isSuper
	^type = #super! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/6/2005 13:27'!
isKeyword
	^type == #keyword ! !

!SHRange methodsFor: '*ecompletion' stamp: 'bar 1/9/2005 14:51'!
isAssignment
	^#(#assignment #ansiAssignment ) includes: type! !

!Symbol methodsFor: '*ecompletion' stamp: 'bar 11/29/2004 22:41'!
separateKeywords
	^ self isKeyword
		ifFalse: [self]
		ifTrue:
			[String streamContents:
				[:s |
				(self findTokens: ':')
					do: [:ea | s nextPutAll: ea, ':']
					separatedBy: [s nextPutAll: '  ']]]
					! !

TestCase subclass: #ECUntypedModelTest
	instanceVariableNames: 'prefValueCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 10/5/2005 23:14'!
testForClassInstVars
	| model locals |
	model _ ECUntypedModel class: ECTestClass temporaries: OrderedCollection new.
	locals _ model entriesOfType: #instVar.
	self assert: locals size == 17.
	self
		assert: (locals includes: 'third').
	self
		assert: (locals includes: 'constantInteger').
	self
		assert: (locals includes: 'complexInit2').
	self
		assert: (locals includes: 'typeSuggestingParameter').
	locals _ model entriesOfType: #self.
	self
		assert: (locals includes: 'self').
	locals _ model entriesOfType: #super.
	self
		assert: (locals includes: 'super').
	model narrowWith: 'fo'.
	locals _ model entriesOfType: #instVar.
	self assert: locals size == 1.
	self
		assert: (locals includes: 'fourth')! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 10/5/2005 23:14'!
testCaseSensitive
	| model locals |
	self assert: ECPreferences caseSensitive.
	model _ ECUntypedModel class: ECTestClass temporaries: OrderedCollection new.
	locals _ model entriesOfType: #instVar.
	self assert: locals size == 17.
	self
		assert: (locals includes: 'third').
	self
		assert: (locals includes: 'constantInteger').
	self
		assert: (locals includes: 'complexInit2').
	self
		assert: (locals includes: 'typeSuggestingParameter').
	model narrowWith: 'fo'! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 10/5/2005 23:08'!
testCaseSensitivity
	| model instances |
	self assert: ECPreferences caseSensitive.
	model _ ECUntypedModel class: ECTestClass temporaries: OrderedCollection new.
	model narrowWith: 'typesugg'.
	self assert: model isEmpty.
	Preferences setPreference: #ecompletionCaseSensitive toValue: false.
	model narrowWith: 'typesugg'.
	instances _ model entriesOfType: #instVar.
	self assert: instances size == 2.
	self
		assert: (instances includes: 'typeSuggestingParameter').
	model narrowWith: 'dict'.
	self assert: model notEmpty.
	self
		assert: ((model entriesOfType: #selector)
				includes: 'Dictionary')! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 12/13/2004 10:40'!
testEmpty
	| model |
	model := ECUntypedModel new.
	self assert: model isEmpty.
	self assert: model entries isEmpty.
	self assert: model entryCount == 0! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 4/11/2005 10:57'!
setUp
	prefValueCase _ ECPreferences caseSensitive.
	ECPreferences setCaseSensitiveness: true! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 12/13/2004 10:40'!
testNarrowWith
	| count model |
	model := ECUntypedModel new.
	self assert: model isEmpty.
	model narrowWith: 'b'.
	count := model entryCount.
	self assert: count == model entries size.
	self assert: count > 100.
	model narrowWith: 'bar'.
	self assert: count > model entryCount.
	model narrowWith: 'barXXXX'.
	self assert: model isEmpty.
	model narrowWith: 'b'.
	self assert: count == model entryCount.
	model narrowWith: 'save'.
	self assert: model isEmpty not.
	model narrowWith: ''.
	self assert: model isEmpty! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 3/1/2006 13:44'!
testAdditionalLocals
	| model locals |
	model _ ECUntypedModel
				class: ECTestClass
				temporaries: (OrderedCollection
						with: (ECLocalEntry contents: 'a' type: #local)
						with: (ECLocalEntry contents: 'b' type: #local))
				additionals: (Array
						with: (ECLocalEntry contents: 'veryImp' type: #local))
				variables: true
				selectors: true.
	locals _ model entriesOfType: #local.
	self
		assert: (locals includes: 'veryImp')! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 10/5/2005 23:08'!
testForClassVars
	| model classVars |
	model _ ECUntypedModel class: ECTestClass temporaries: OrderedCollection new.
	classVars _ model entriesOfType: #classVar.
	self assert: classVars size >= 2.
	self
		assert: (classVars includes: 'SuperClassVar').
	self
		assert: (classVars includes: 'ClassVar')! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 12/13/2004 14:03'!
testTitle
	| model |
	model := ECUntypedModel
				class: ECTestClass
				temporaries: #().
	self assert: model title isNil! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 3/1/2006 13:44'!
testForClassLocals
	| model locals temps |
	temps _ #('loc1' 'x2' 'bar' 'var' )
				collect: [:each | ECLocalEntry contents: each type: #local].
	model _ ECUntypedModel class: ECTestClass temporaries: temps.
	locals _ model entriesOfType: #local.
	self assert: locals size == 4.
	self
		assert: (locals includes: 'loc1').
	self
		assert: (locals includes: 'x2').
	self
		assert: (locals includes: 'bar').
	self
		assert: (locals includes: 'var').
	model narrowWith: 'l'.
	locals _ model entriesOfType: #local.
	self assert: locals size == 1.
	self
		assert: (locals includes: 'loc1')! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 12/17/2004 22:50'!
testMessage
	| model |
	model _ ECUntypedModel class: ECTestClass temporaries: #('a' 'b' ).
	self assert: model notEmpty.
	self assert: model hasMessage.
	self assert: model message = 'press key for selectors'.
	model narrowWith: 'b'.
	self shouldnt: model hasMessage.
	model narrowWith: ''.
	self assert: model hasMessage.
	self assert: model message = 'press key for selectors'.
	model narrowWith: 'hagadagadu'.
	self assert: model hasMessage.
	self assert: model message = 'no completions found'.
	model _ ECUntypedModel new.
	self assert: model hasMessage.
	self assert: model message = 'press key for selectors'! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 12/13/2004 10:40'!
testNoEntriesWithSpace
	| model separatorEntry |
	model := ECUntypedModel new.
	self assert: model isEmpty.
	model narrowWith: 'b'.
	separatorEntry := model entries detect: 
					[:each | 
					(each value asString detect: [:char | char isSeparator] ifNone: []) notNil]
				ifNone: [].
	self assert: separatorEntry isNil! !

!ECUntypedModelTest methodsFor: 'testing' stamp: 'bar 4/11/2005 10:59'!
tearDown
	ECPreferences setCaseSensitiveness: prefValueCase! !

TestCase subclass: #ECEntryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECEntryTest methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 16:14'!
testPrintOn
	| entry |
	entry _ ECSelectorEntry contents: 'compute' type: #unary:.
	self assert: 'ECSelectorEntry(compute,unary:)' = entry printString! !

!ECEntryTest methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 13:57'!
testCompletion
	| entry |
	entry _ ECSelectorEntry contents: 'makeItHappen' type: #unary:.
	self assert: entry completion = #makeItHappen! !

!ECEntryTest methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 13:26'!
testInstance
	| entry |
	entry _ ECInstVarEntry contents: 'abc' type: #instVar:.
	self assert: entry isInstance! !

!ECEntryTest methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 13:44'!
testLocal
	| entry |
	entry _ ECLocalEntry contents: 'abc' type: #patternArg:.
	self assert: entry contents = 'abc'.
	self assert: entry type = #patternArg:.
	self assert: entry isLocal! !

TestCase subclass: #ECTypedModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECTypedModelTest methodsFor: 'as yet unclassified' stamp: 'bar 12/17/2004 22:44'!
testMessage
	| model |
	model := ECTypedModel class: ECTestClass.
	self shouldnt: model hasMessage.
	model narrowWith: 'hagadagadu'.
	self assert: model hasMessage.
	self assert: model message = 'no completions found'! !

!ECTypedModelTest methodsFor: 'as yet unclassified' stamp: 'bar 10/5/2005 23:21'!
testExpand
	| model selectors |
	model _ ECTypedModel class: ECTestClass.
	self assert: (model entriesOfType: #locals) isEmpty.
	self assert: (model entriesOfType: #instance) isEmpty.
	model toggleExpand.
	selectors _ model entriesOfType: #selector.
	self assert: selectors size == 6.
	self
		assert: (selectors includes: #initialize).
	self
		assert: (selectors includes: #lowPriorityOverrides:).
	self
		assert: (selectors includes: #testIt:).
	model toggleExpand.
	selectors _ model entriesOfType: #selector.
	self assert: selectors size > 100.
	self
		assert: (selectors includes: #instVarAt:).
	self
		assert: (selectors includes: #initialize).
	self
		assert: (selectors includes: #lowPriorityOverrides:).
	self
		assert: (selectors includes: #testIt:).
	self
		assert: (selectors includes: #instVarAt:).
	model toggleExpand.
	selectors _ model entriesOfType: #selector.
	self assert: selectors size == 6! !

!ECTypedModelTest methodsFor: 'as yet unclassified' stamp: 'bar 12/13/2004 10:45'!
testTitle
	| model |
	model := ECTypedModel class: ECTestClass.
	self assert: 'ECTestClass' = model title! !

!ECTypedModelTest methodsFor: 'as yet unclassified' stamp: 'bar 12/13/2004 10:41'!
testTyped
	| model selectors |
	model := ECTypedModel class: ECTestClass.
	self assert: (model entriesOfType: #locals) size == 0.
	self assert: (model entriesOfType: #instance) size == 0.
	selectors := model entriesOfType: #selector.
	self assert: selectors size > 0.
	self assert: (selectors includes: #initialize).
	self assert: (selectors includes: #lowPriorityOverrides:).
	self assert: (selectors includes: #testIt:).
	model narrowWith: 'low'.
	selectors := model entriesOfType: #selector.
	self deny: (selectors includes: #initialize).
	self assert: (selectors includes: #lowPriorityOverrides:).
	self deny: (selectors includes: #testIt:)! !

TestCase subclass: #ECOverrideModelTest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECOverrideModelTest methodsFor: 'testing' stamp: 'bar 12/6/2004 16:45'!
testCompletionAtWithReturn
	| completion |
	completion := model completionAt: 3.
	self assert: completion = 'toBeOverridenWithReturn
	^super toBeOverridenWithReturn'! !

!ECOverrideModelTest methodsFor: 'testing' stamp: 'bar 12/13/2004 10:41'!
setUp
	model := ECOverrideModel class: ECTestClass.
	model toggleExpand! !

!ECOverrideModelTest methodsFor: 'testing' stamp: 'bar 12/6/2004 17:10'!
testCompletionAt
	| completion |
	completion := model completionAt: 2.
	self assert: completion = 'toBeOverriden: anArgument
	super toBeOverriden: anArgument'! !

!ECOverrideModelTest methodsFor: 'testing' stamp: 'bar 12/13/2004 10:46'!
testTitle
	self assert: '(override) ECTestSuperClass' = model title! !

!ECOverrideModelTest methodsFor: 'testing' stamp: 'bar 12/6/2004 17:10'!
testExpand
	| size |
	size := model entries size.
	self assert: size == model entries size! !

!ECOverrideModelTest methodsFor: 'testing' stamp: 'bar 12/6/2004 17:11'!
testOverride
	| selectors |
	self assert: model notEmpty.
	self assert: model entries size = 3.
	selectors := model entriesOfType: #selector.
	self
		assert: (selectors includes: #toBeOverriden:).
	self
		assert: (selectors includes: #initialize).
	self
		assert: (selectors includes: #toBeOverridenWithReturn)! !

TestCase subclass: #ECClassVarTypeGuesserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECClassVarTypeGuesserTest methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:14'!
testClassVar
	self
		guessVariable: 'ClassVar'
		in: ECTestClass
		expected: ByteString! !

!ECClassVarTypeGuesserTest methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:23'!
testSuperClassVar
	self
		guessVariable: 'SuperClassVar'
		in: ECTestClass
		expected: Dictionary ! !

!ECClassVarTypeGuesserTest methodsFor: 'as yet unclassified' stamp: 'bar 8/10/2005 14:05'!
guessVariable: aString in: aClass expected: theClassExpected 
	| typeGuesser result |
	typeGuesser _ ECClassVarTypeGuesser variableName: aString class: aClass.
	result _ typeGuesser perform.
	self assert: result == theClassExpected! !

!ECClassVarTypeGuesserTest methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:57'!
testDependentsFieldsClassVar
	self
		guessVariable: 'DependentsFields'
		in: ECTestClass
		expected: WeakIdentityKeyDictionary! !

TestCase subclass: #ECContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 10/5/2005 22:51'!
testBlockTemporariesBoxed
	| text temps context |
	text _ 'testIt
	| a b c |
	a _ [ :each | |d | d = a ifTrue:[ |x|  ] ifFalse:[ |y|.
	^self'.
	context _ self createContextFor: text at: 73.
	temps _ context temporaries
				collect: [:each | each contents].
	self assert: temps size = 6.
	self assert: temps first = 'a'.
	self assert: temps second = 'b'.
	self assert: temps third = 'c'.
	self assert: temps fourth = 'each'.
	self assert: temps fifth = 'd'.
	self assert: temps sixth = 'y'! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/20/2004 23:17'!
testUntypedSelectorsOnly
	| text context model |
	text _ 'testIt: aRectangle
	| ab bc bd |
	ab '.
	context _ self createContextFor: text at: text size.
	model _ context model.
	self assert: model hasMessage.
	self assert: model message = 'press key for selectors'.
	context narrowWith: 'a'.
	self assert: (model entriesOfType: #selector) notEmpty.
	self assert: (model entriesOfType: #local) isEmpty.
	self assert: (model entriesOfType: #instance) isEmpty! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/13/2004 10:40'!
testCreateModel
	| text context |
	text := 'testIt: aRectangle
	aRectangle printS'.
	context := self createContextFor: text at: text size.
	self assert: context createModel class == ECTypedModel.
	text := 'testIt:'.
	context := self createContextFor: text at: text size.
	self assert: context createModel class = ECOverrideModel.
	text := 'testIt: rect
	rect is'.
	context := self createContextFor: text at: text size.
	self assert: context createModel class = ECUntypedModel! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/12/2004 23:03'!
testReceiverConstant
	| text context |
	text := 'testIt
	15r16 printS'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Number.
	text := 'testIt
	''test'' printS'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == String.
	text := 'testIt
	true ifTrue:'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == True.
	text := 'testIt
	false  "this is it"
		printStr'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == False.
	text := 'testIt
	a _ [ :test | test * test ] 
		v'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == BlockContext.
	text := 'testIt
	$c as'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Character.
	text := 'testIt
	#gaga as'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Symbol.
	text := 'testIt
	#( 1 2 3) as'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Array.
! !

!ECContextTest methodsFor: 'private' stamp: 'bar 12/13/2004 15:46'!
createContextFor: aString at: anInteger 
	^ ECContext
		controller: ECController new
		class: ECTestClass
		source: aString
		position: anInteger! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 21:27'!
testUntypedVarsOnly
	self checkUntypedVariablesOnly: 'testIt
	'.
	self checkUntypedVariablesOnly: '+ aTest
	'.
	self checkUntypedVariablesOnly: 'gaga: aTest
	'.
	self checkUntypedVariablesOnly: 'gaga
	^ '.
	self checkUntypedVariablesOnly: 'testIt 
	a ifTrue:[ '.
	self checkUntypedVariablesOnly: 'testIt 
	a ifTrue:[ :each'.
	self checkUntypedVariablesOnly: 'testIt 
	a ifTrue:[ :each |'.
	self checkUntypedVariablesOnly: 'testIt 
	a ifTrue:[ :each | '.
	self checkUntypedVariablesOnly: 'testIt
	<primitive: 67> 
	'.
	self checkUntypedVariablesOnly: 'testIt
	ab _'.
	self checkUntypedVariablesOnly: 'testIt
	ab _ '.
	self checkUntypedVariablesOnly: 'self compare: '.
	self checkUntypedVariablesOnly: 'self compare: x caseSensitive: '.
	self checkUntypedVariablesOnly: 'self gaga: x gugu: ('.
	self checkUntypedVariablesOnly: 'testIt
	a _ 15 + '! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/12/2004 10:06'!
testCompletionTokenEmpty
	| text context |
	text := 'testIt: aRectangle
	| abc |
	test.
	abc daf '.
	context := self createContextFor: text at: text size.
	self assert: context completionToken = ''! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/18/2004 22:23'!
testInTheMiddelOfAWord
	| text context |
	text _ 'hagada'.
	context _ self createContextFor: text at: 4.
	self assert: context completionToken = 'haga'.
! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:25'!
testReceiverClassVar
	| text context |
	text _ 'testIt
	ClassVar '.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == ByteString! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/21/2004 22:20'!
testReceiverArgument
	| text context |
	text _ 'testIt: aRectangle
	aRectangle printS'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == Rectangle.
	text _ 'testIt: rect
	rect is'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass isNil! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/13/2004 09:45'!
testReceiverCascade
	| text context |
	text := 'testIt
	| b |
	b _ Stream new.
	b 
		nextPutAll: ''test''; 
		nextPut: $c;
		s'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Stream.
	text := 'testIt
	| b |
	b _ Stream new
		nextPutAll: ''test''; 
		nextPut: $c with: true;
		s'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Stream.
	text := 'testIt: aStream
	| test |
	aStream
		nextPutAll: ''test''; 
		nextPut: $c with: true;
		s'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Stream.
	text := 'testIt: aStream
	aStream
		nextPutAll: ''test''; 
		nextPut: $c with: true;
		s'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Stream! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/13/2004 16:28'!
testReceiverTempVar2
	| text context |
	text := 'openMenuFor: aParagraphEditor 
	| theMenu |
	context := ECContext
				controller: self
				class: model receiverClass
				source: aParagraphEditor text string
				position: aParagraphEditor caret - 1.
	editor := aParagraphEditor.
	theMenu := ECMenuMorph
				controller: self
				position: (aParagraphEditor selectionPosition: context completionToken).
	theMenu isClosed
		ifFalse: [menuMorph := theMenu]. theMenu o'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == ECMenuMorph! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/12/2004 23:05'!
testReceiverGlobalVarNew
	| text context |
	text := 'testIt
	Dictionary new a'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Dictionary.
! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 1/6/2005 22:00'!
testEmpty
	self createContextFor: '' at: 0! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/11/2004 23:42'!
testCompletionToken
	| text context |
	text := 'testIt: aRectangle
	| abc |
	test.
	abc daf'.
	context := self createContextFor: text at: text size.
	self assert: context completionToken = 'daf'! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/12/2004 22:38'!
testReceiverGlobal
	| text context |
	text := 'testIt
	Dictionary n'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Dictionary class.
! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 12/18/2004 23:52'!
testUnfinishedString
	| text context |
	text _ 'testIt: aRectangle
	| a b c |
	self test: ''test it and so'.
	context _ self createContextFor: text at: text size.
	self assert: context completionToken = 'so'.
! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 10/5/2005 22:52'!
testBlockTemporaries
	| text temps context |
	text _ 'testIt
	| a b c |
	a _ [ :each | |d | ^d].
	^self'.
	context _ self createContextFor: text at: 39.
	temps _ context temporaries
				collect: [:each | each contents].
	self assert: temps size = 5.
	self assert: temps first = 'a'.
	self assert: temps second = 'b'.
	self assert: temps third = 'c'.
	self assert: temps fourth = 'each'.
	self assert: temps fifth = 'd'! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 10/5/2005 22:51'!
testTemporaries
	| text temps context |
	text _ 'testIt: aRectangle
	| a b c |
	a _ [ :each | |d | ^d].
	^self'.
	context _ self createContextFor: text at: text size.
	temps _ context temporaries
				collect: [:each | each contents].
	self assert: temps size = 4.
	self assert: temps first = 'aRectangle'.
	self assert: temps second = 'a'.
	self assert: temps third = 'b'.
	self assert: temps fourth = 'c'! !

!ECContextTest methodsFor: 'as yet unclassified' stamp: 'bar 8/4/2005 21:29'!
testReceiverTempVar
	| text context |
	text _ 'testIt
	| aha |
	aha _ ''test''.
	aha p'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == String.
	text _ 'testIt
	| aha |
	ah _ ''test''.
	ah p'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass isNil.
	text _ 'testIt
	| aha |
	aha _ constantString.
	aha p'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == ByteString.
	text _ 'testIt
	| aha |
	aha _ constant asDate.
	aha p'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass isNil.
	text _ 'testIt
	| aha bili |
	aha _ constantString.
	bili _ aha.
	bili p'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == ByteString.
	text _ 'testIt
	| aha bili |
	aha _ constantString.
	bili _ aha _ 15.
	bili p'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass = Number.
	text _ 'testIt
	| aha bili |
	aha _ constantString.
	bili _ 15.
	bili _ aha.
	bili p'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == Number.
	text _ 'testIt
	[ :each | |a| a _ 16. a print'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == Number.
	text _ 'testIt
	[ :each | |a| a _ Dictionary new. a print'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == Dictionary.
	text _ 'testIt
	[ :each | |a| a _ Dictionary. a print'.
	context _ self createContextFor: text at: text size.
	self assert: context receiverClass == Dictionary class! !

!ECContextTest methodsFor: 'private' stamp: 'bar 10/5/2005 23:05'!
checkUntypedVariablesOnly: aString 
	| context model |
	context _ self createContextFor: aString at: aString size.
	self assert: context isVariablesOnly.
	model _ context model.
	self assert: model hasMessage not.
	self assert: (model entriesOfType: #instVar) notEmpty.
	context narrowWith: 'a'.
	self assert: (model entriesOfType: #selector) isEmpty! !

TestCase subclass: #ECStringSortingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECStringSortingTest methodsFor: 'as yet unclassified' stamp: 'bar 8/6/2005 22:22'!
testCaseSensitiveMap
	| map colon o |
	map _ String classPool at: #CaseSensitiveOrder.
	colon _ map at: $: asciiValue + 1.
	o _ map at: $O asciiValue + 1.
	self assert: colon < o! !

!ECStringSortingTest methodsFor: 'as yet unclassified' stamp: 'bar 8/6/2005 22:16'!
testCompareWithCase
	self assert: ('at:' compare: 'atOne' caseSensitive: true)
			== 1! !

!ECStringSortingTest methodsFor: 'as yet unclassified' stamp: 'bar 8/6/2005 20:55'!
testCompare
	self assert: ('at:' compare: 'atOne' caseSensitive: false)
			== 1! !

TestCase subclass: #ECInstVarTypeGuesserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Tests'!

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 2/20/2006 15:12'!
testMessageSend2
	self 
		guessVariable: 'messageSend2'
		in: ECTestClass
		expected: nil! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 2/20/2006 15:10'!
testComplexInit
	self 
		guessVariable: 'complexInit'
		in: ECTestClass
		expected: ByteSymbol ! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 13:47'!
testConstantInteger
	self 
		guessVariable: 'constantInteger'
		in: ECTestClass
		expected: SmallInteger! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 13:47'!
testMessageSend
	self 
		guessVariable: 'messageSend'
		in: ECTestClass
		expected: Dictionary! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 13:47'!
testConstantIntegerNil
	self
		guessVariable: 'constantNil'
		in: ECTestClass
		expected: nil! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 13:46'!
testConstantArray
	self 
		guessVariable: 'constantArray'
		in: ECTestClass
		expected: Array! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 8/4/2005 21:30'!
testConstantSymbol
	self
		guessVariable: 'constantSymbol'
		in: ECTestClass
		expected: ByteSymbol! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 13:46'!
testConstantBoolean
	self 
		guessVariable: 'constantBoolean'
		in: ECTestClass
		expected: True! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 10:41'!
tesConstantFalse
	self 
		guessVariable: 'false'
		in: ECTestClass
		expected: False.
	self 
		guessVariable: 'false'
		in: nil
		expected: False! !

!ECInstVarTypeGuesserTest methodsFor: 'private' stamp: 'bar 8/9/2005 23:36'!
guessVariable: aString in: aClass expected: theClassExpected 
	| typeGuesser result |
	typeGuesser _ ECInstVarTypeGuesser variableName: aString class: aClass.
	result _ typeGuesser perform.
	self assert: result == theClassExpected! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 16:42'!
testGlobalVarKeyword
	self
		guessVariable: 'globalVarKeyword'
		in: ECTestClass
		expected: SortedCollection! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 13:48'!
testSuperWithAnotherInit
	self 
		guessVariable: 'superInstVar'
		in: ECTestClass
		expected: Dictionary! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 13:48'!
testTypeSuggestingParameter
	self 
		guessVariable: 'typeSuggestingParameter2'
		in: ECTestClass
		expected: Rectangle! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 8/6/2005 22:33'!
testConstantString
	self
		guessVariable: 'constantString'
		in: ECTestClass
		expected: ByteString! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 17:19'!
testGlobalVarKeyword2
	self
		guessVariable: 'globalVarKeyword2'
		in: ECTestClass
		expected: SortedCollection! !

!ECInstVarTypeGuesserTest methodsFor: 'testing' stamp: 'bar 12/13/2004 10:41'!
testComplexInit2
	self 
		guessVariable: 'complexInit2'
		in: ECTestClass
		expected: Dictionary! !

InstructionClient subclass: #ECVarTypeGuesser
	instanceVariableNames: 'types receiverClass variableName found currentMethod hasSend contextCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECVarTypeGuesser commentStamp: '<historical>' prior: 0!
I'm an InstructionClient that tries to guess the type of a given instance variable name of a class. !

!ECVarTypeGuesser methodsFor: 'public' stamp: 'bar 8/11/2005 13:56'!
perform
	| infos infosOfMethod methodRefs |
	variableName isEmpty
		ifTrue: [^ nil].
	methodRefs _ self methodRefs.
	methodRefs
		ifNil: [^ nil].
	( methodRefs isKindOf: Class ) ifTrue:[^methodRefs ].
	contextCount _ 0.
	infos _ SortedCollection
				sortBlock: [:a :b | a priority <= b priority].
	methodRefs
		do: [:each | 
			self prepare: each.
			infosOfMethod _ self typeOfVarIn: each compiledMethod.
			infos addAll: infosOfMethod].
	infos notEmpty
		ifTrue: [^ infos first type].
	^ nil! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 8/11/2005 13:32'!
typeOfVarIn: aMethod 
	"Answer whether the receiver references an instance variable."
	| scanner end type infos |
	scanner _ InstructionStream on: aMethod.
	end _ scanner method endPC.
	currentMethod _ aMethod.
	infos _ OrderedCollection new.
	[scanner pc <= end]
		whileTrue: [(self interpretNextInstructionUsing: scanner)
				ifTrue: [type _ self computeVarType.
					type
						ifNotNil: [infos add: type]]].
	^ infos! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:07'!
blockReturnTop
	contextCount _ contextCount - 1! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 8/11/2005 13:19'!
prepare: aCompiledMethod ! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 8/11/2005 13:14'!
pushConstant: value 
	"Push Constant, value, on Top Of Stack bytecode."
	| info |
	contextCount > 0
		ifTrue: [^ self].
	value
		ifNotNil: [info _ ECTypeInfo definedByLiteral: value class.
			types add: info]! !

ECVarTypeGuesser subclass: #ECInstVarTypeGuesser
	instanceVariableNames: 'varIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECInstVarTypeGuesser commentStamp: '<historical>' prior: 0!
I'm a simple InstructionClient that tries to guess the type of a given instance variable name of a class. !

!ECInstVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 2/26/2006 09:53'!
guessWithRoelTyper
	| typeInfos typeInfo roelTyper |
	(roelTyper _ Smalltalk
				at: #TypeCollector
				ifAbsent: [])
		ifNil: [^ nil].
	typeInfos _ roelTyper typeInstvarsOfClass: receiverClass.
	typeInfo _ typeInfos
				at: variableName asSymbol
				ifAbsent: [^ nil].
	typeInfo types size ~= 1
		ifTrue: ["Transcript show: 'ignoring roel!!' , variableName printString."
			^ nil].
	typeInfo _ typeInfo types first.
	^ (typeInfo == UndefinedObject
			or: [typeInfo == Object])
		ifTrue: [^ nil]
		ifFalse: [typeInfo]! !

!ECInstVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 2/20/2006 14:55'!
methodRefs
	| theClass selectors |
	theClass := receiverClass classThatDefinesInstanceVariable: variableName.
	selectors := theClass whichSelectorsStoreInto: variableName.
	^ selectors collect:[ :each | MethodReference new setStandardClass: theClass methodSymbol: each ].! !

!ECInstVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 8/11/2005 13:16'!
popIntoReceiverVariable: offset 
	varIndex = offset ifTrue: [found _ true] ifFalse: [self reset]! !

!ECInstVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:58'!
prepare: aCompiledMethod 
	| theClass |
	super prepare: aCompiledMethod.
	theClass _ aCompiledMethod actualClass.
	varIndex _ (theClass allInstVarNames indexOf: variableName)
				- 1. ! !

!ECInstVarTypeGuesser methodsFor: 'public' stamp: 'bar 2/20/2006 15:09'!
perform
	| result |
	result := self guessWithRoelTyper.
	^ result  
		ifNil:[super perform] 
		ifNotNil: [result]
! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/1/2004 21:47'!
interpretNextInstructionUsing: aScanner 
	found := false.
	aScanner interpretNextInstructionFor: self.
	^found
! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 8/11/2005 13:03'!
popIntoLiteralVariable: anAssociation 
	"Remove Top Of Stack And Store Into Literal Variable bytecode."
	self reset! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:15'!
pushTemporaryVariable: offset 
	"Push Contents Of Temporary Variable Whose Index Is the  
	argument, offset, On Top Of Stack bytecode."
	| info |
		contextCount > 0 ifTrue:[^self].

	info := ECTypeInfo definedByTemporaryVar: offset.
	types add: info! !

ECVarTypeGuesser subclass: #ECClassVarTypeGuesser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Model'!

!ECClassVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:14'!
send: selector super: supered numArgs: numberArguments 
! !

!ECClassVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:07'!
popIntoReceiverVariable: offset 
	self reset! !

!ECClassVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:52'!
popIntoLiteralVariable: anAssociation 
	anAssociation key == variableName asSymbol
		ifTrue: [
			found _ true]
		ifFalse: [self reset]! !

!ECClassVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:55'!
methodRefs
	| theClass classVarAssoc |
	theClass _ receiverClass classThatDefinesClassVariable: variableName.
	classVarAssoc _ theClass classPool associationAt: variableName asSymbol.
	classVarAssoc value
		ifNil: [^ SystemNavigation new allCallsOn: classVarAssoc]
		ifNotNil: [^ classVarAssoc value class]! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:08'!
popIntoTemporaryVariable: offset 
	"Remove Top Of Stack And Store Into Temporary Variable bytecode."
	self reset
! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:06'!
pushActiveContext
	"Push Active Context On Top Of Its Own Stack bytecode."
	contextCount _ contextCount + 1! !

!ECVarTypeGuesser methodsFor: 'instance creation' stamp: 'bar 12/13/2004 17:26'!
initialize
	super initialize.
	types := OrderedCollection new.
	hasSend := false.
	contextCount := 0! !

!ECVarTypeGuesser methodsFor: 'private' stamp: 'bar 12/13/2004 17:14'!
reset
	contextCount > 0 ifTrue:[^self].
	types reset.
	hasSend := false.! !

!ECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: 'bar 12/8/2004 13:47'!
variableName: aString class: aClass 
	^self variableName: aString source: nil class: aClass ! !

!ECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: 'bar 12/9/2004 18:37'!
getClassFromTypeSuggestingName: aString 
	| firstUppercaseLetter className aStream aClass |
	aStream := WriteStream on: String new.
	aStream nextPut: aString first asUppercase.
	aStream
		nextPutAll: (aString copyFrom: 2 to: aString size).
	className := aStream contents.
	aClass := Smalltalk
				at: className asSymbol
				ifAbsent: [].
	(aClass isKindOf: Class)
		ifTrue: [^ aClass].
	firstUppercaseLetter := aString indexOfFirstUppercaseCharacter.
	className := firstUppercaseLetter > 1
				ifTrue: [aString copyFrom: firstUppercaseLetter to: aString size]
				ifFalse: [^ nil].
	aClass := Smalltalk
				at: className asSymbol
				ifAbsent: [].
	(aClass isKindOf: Class)
		ifTrue: [^ aClass].
	^ nil! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:15'!
pushLiteralVariable: anAssociation 
	"Push Contents Of anAssociation On Top Of Stack bytecode."
	| info |
	contextCount > 0 ifTrue:[^self].

	info := ECTypeInfo definedByMessageSend: anAssociation value.
	types add: info! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:15'!
send: selector super: supered numArgs: numberArguments 
	"Send Message With Selector, selector, bytecode. The argument,  
	supered, indicates whether the receiver of the message is specified with 
	'super' in the source method. The arguments of the message are found  
	in  
	the top numArguments locations on the stack and the receiver just  
	below them."
	contextCount > 0 ifTrue:[^self].

	hasSend := true! !

!ECVarTypeGuesser methodsFor: 'instance creation' stamp: 'bar 12/13/2004 13:55'!
setVariableName: aString source: aSourceString class: aClass 
	variableName := aString.
	receiverClass := aClass! !

!ECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: 'bar 4/11/2005 11:32'!
variableName: aString source: sourceString class: aClass 
	| newInstance |
	newInstance _ self basicNew initialize.
	newInstance
		setVariableName: aString
		source: sourceString
		class: aClass.
	^ newInstance! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 8/11/2005 13:15'!
computeVarType
	| info tempNames name |
	types ifEmpty: [^ nil].
	info _ types first.
	(hasSend and: [info isDefinedByMessageSend not]) 
		ifTrue: 
			[info type: nil.
			^ info].
	info isDefinedByTemporary not ifTrue: [^ info].
	tempNames _ (receiverClass compilerClass new 
				parse: currentMethod getSourceFromFile asString
				in: receiverClass
				notifying: nil) tempNames.
	name _ tempNames at: info temporaryOffset + 1.
	info type: (self class getClassFromTypeSuggestingName: name).
	^ info! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 12/18/2004 09:26'!
changeCaretDuring: aBlock
	| caret |
	caret := self startBlock stringIndex.
	[aBlock value] ensure:[self selectAt: caret]! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 10/18/2004 07:09'!
caret
	^self startBlock stringIndex! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 12/13/2004 15:28'!
isCaretBehindChar
	| pos |
	pos := self caret - 1.
	^ pos < 1
		ifTrue: [false]
		ifFalse: [(self text at: pos) isAlphaNumeric]! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 12/13/2004 14:49'!
selectionPosition: aString 
	| caret position bottomLeft topLeft |
	caret := self startBlock stringIndex.
	[self selectAt: caret - aString size.
	bottomLeft := paragraph selectionRects first bottomLeft.
	topLeft := self morph owner submorphBounds topLeft.
	position := topLeft + bottomLeft]
		ensure: [self selectAt: caret].
	^ position! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 12/18/2004 23:46'!
wordAtCaret
	^paragraph text asString wordBefore: self caret -1
! !

Morph subclass: #ECDetailMorph
	instanceVariableNames: 'entryDescription title description category arrowPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-View'!

!ECDetailMorph commentStamp: '<historical>' prior: 0!
I display some detail information for a selected ECEntry in the ECMenuMorph.
The content I show, is provided by an ECDetailContentProvider subclass. 
!

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 18:48'!
drawMessageOn: aCanvas 
	| factor rectangle |
	factor _ ECMenuMorph itemHeight.
	rectangle _ self bounds top: self bounds bottom - factor.
	rectangle _ rectangle left: self contentBounds left.
	aCanvas
		line: rectangle topLeft + (0 @ 2)
		to: rectangle topRight + (-3 @ 2)
		color: Color gray.
	entryDescription hasType
		ifTrue: [aCanvas
				drawString: 'Ctrl-b=browse'
				in: (rectangle top: rectangle top + 3)
				font: ECMenuMorph messageFont
				color: Color gray]! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'bar 3/1/2006 16:31'!
titleBounds
	^ self contentBounds top: self contentBounds top + 10! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 21:16'!
drawOn: aCanvas 
	super drawOn: aCanvas.
	arrowPosition ifNotNil: [
	self drawArrowOn: aCanvas.
	self drawMessageOn: aCanvas]! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'bar 3/2/2006 18:48'!
initialize
	| childBounds |
	super initialize.
	childBounds _ self contentBounds.
	category _ StringMorph contents: 'test' font: ECMenuMorph messageFont.
	category bounds: childBounds.
	self addMorph: category.
	title _ StringMorph contents: '' font: ECMenuMorph titleFont.
	title bounds: self titleBounds.
	self addMorph: title.
	description _ TextMorph new.
	description autoFit: false.
	description bounds: self descriptionBounds.
	description borderWidth: 0.
	self addMorph: description! !

!ECDetailMorph class methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:39'!
height
	^(ECMenuMorph itemHeight * 10.5)! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 17:44'!
position: aPoint 
	| y |
	arrowPosition _ aPoint.
	y _ aPoint y + self class height.
	y _ y > Display height
				ifTrue: [Display height - self class height]
				ifFalse: [aPoint y - ECMenuMorph itemHeight].
	super position: aPoint x @ y! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 17:39'!
bounds
	^ super bounds topLeft extent: ECMenuMorph itemWidth * 1.5 @ self class height! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/1/2006 14:56'!
contentBounds
	| factor rectangle |
	factor _ ECMenuMorph itemHeight.
	rectangle _ self bounds top: self bounds top + 3.
	rectangle _ rectangle left: rectangle left + (factor * 2.0).
	rectangle _ rectangle bottom: rectangle bottom - factor. 
	^ rectangle! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 2/26/2006 11:48'!
defaultColor
	^ ECMenuMorph backgroundColor. ! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 17:47'!
drawArrowOn: aCanvas 
	| point factor poligon |
	factor _ ECMenuMorph itemHeight.
	point _ arrowPosition.
	poligon _ OrderedCollection new.
	poligon add: point.
	poligon add: (point _ point translateBy: factor / 2 @ 0).
	poligon add: (point _ point translateBy: 0 @ (factor * -0.5)).
	poligon add: (point _ point translateBy: factor @ factor).
	poligon add: (point _ point translateBy: factor * -1 @ factor).
	poligon add: (point _ point translateBy: 0 @ (factor * -0.5)).
	poligon add: (point _ point translateBy: factor * -0.5 @ 0).
	aCanvas drawPolygon: poligon fillStyle: ECMenuMorph scrollColor! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'bar 3/1/2006 16:32'!
entryDescription: anECEntryDescription 
	| categoryContents |
	entryDescription _ anECEntryDescription.
	title contents: (entryDescription title
		ifNil: [description bounds: self titleBounds. String new]
		ifNotNil: [description bounds: self descriptionBounds. entryDescription title]).
	
	description contentsWrapped: entryDescription description.
	categoryContents _ entryDescription label.
	category contents: categoryContents! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'bar 3/1/2006 16:30'!
descriptionBounds
	^ self contentBounds top: self contentBounds top + 30! !

Morph subclass: #ECMenuMorph
	instanceVariableNames: 'selected firstVisible titleStringMorph controller context pageHeight detailMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-View'!

ECMenuMorph class
	instanceVariableNames: 'messageFont instanceVariablesFont localVariablesFont titleFont classVariablesFont'!

!ECMenuMorph commentStamp: '<historical>' prior: 0!
I show the possible completions in a menu like appearance. The user may choose an entry from my list and complete the word he was typing in the editor. I'm showed with the Tab key and will be deleted when with ESC key or when a successful completion occurs. The following keystrokes are supported:

Ctrl-Space or Tab: Open a new morph. Tab requires at least one character in front of the cursor. When already open complete the selected entry. 
Esc: Close me
Ctrl+u: Change to untyped mode, so I show all selectors of all classes in the system and the variables that are accessible to the current context.
Arrow Up: Move one entry up.
Arrow Down: Move one entry down
Enter: (like Ctrl-Space and Tab): Complete with the selected item and close the morph
any letter or digit: Narrow the completion further
Ctrl+t: Toggle the expand flag. When expand is disabled, you don't see selectors belonging to Object and ProtoObject. 

!

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 8/13/2005 18:34'!
convertToSHSymbol: aSymbol 
	| |
	^ (SHTextStylerST80 new attributesFor: aSymbol)
			~= nil
		ifTrue: [aSymbol]
		ifFalse: [#default].! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/17/2004 23:28'!
narrowCompletion
	| model |
	selected _ 0.
	firstVisible _ 1.
	model _ context model.
	model narrowWith: context completionToken.
	(model entries size = 1
			and: [context completionToken notEmpty])
		ifTrue: [self
				insertCompletion: (model completionAt: 1).
			self delete.
			^ false].
	model notEmpty
		ifTrue: [selected _ 1].
	self show.
	^true! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 2/21/2006 21:32'!
currentPage
	^(self selected - 1 // self pageHeight ) + 1.! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 1/6/2005 08:44'!
prepareRectForNextRow: aRectangle 
	^aRectangle translateBy: 0 @ self class itemHeight! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 16:14'!
isClosed
	^ owner isNil! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 11/19/2004 20:54'!
drawTopScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	arrowHeight := self class scrollArrowSize.
	point := self bounds topLeft translateBy: 6 @ 11.
	aPoligon := Array 
				with: point
				with: (point translateBy: arrowHeight @ 0)
				with: (point translateBy: arrowHeight / 2 @ arrowHeight negated).
	aCanvas 
		drawPolygon: aPoligon 
		fillStyle: self class scrollColor. 
	! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 13:41'!
delete
	super delete.
	controller menuClosed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
end
	self gotoPage: self pageCount.
	self changed.! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 11/25/2004 09:48'!
drawTitleOn: aCanvas
	"| morphicTransform angle |
	angle := 90 degreesToRadians.
	morphicTransform := MorphicTransform offset: self position angle: angle scale: 1.0.
	aCanvas 
		transformBy: morphicTransform
		clippingTo: self owner innerBounds
		during: [:myCanvas | myCanvas drawString:'Ruben' at: self position font: self class titleFont color: Color blue]
		smoothing: 1."
		! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 3/2/2006 17:33'!
pageCount
	self itemsCount == self pageHeight
		ifTrue: [^ 1].
	^ self itemsCount // self pageHeight + 1! !

!ECMenuMorph class methodsFor: 'instance creation' stamp: 'bar 12/6/2004 17:01'!
completeParagraph: aParagraph editor: aParagraphEditor 
	| newObject |
	newObject := self new.
	newObject setParagraph: aParagraph editor: aParagraphEditor.
	^ newObject. ! !

!ECMenuMorph methodsFor: 'private' stamp: 'pk 6/3/2004 16:31'!
visibleItemsCount.

	^ self lastVisible - self firstVisible + 1! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'bar 12/17/2004 23:28'!
setController: aECController position: aPoint 
	controller _ aECController.
	context _ controller context.
	self createTitle.
	self position: aPoint - (20 @ 0).
	self narrowCompletion
		ifTrue: [self openInWorld]. ! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'bar 12/13/2004 11:42'!
createTitle
	| transformationMorph titleString |
	titleString := context model title.
	titleString
		ifNil: [^ self].
	transformationMorph := TransformationMorph new.
	self addMorph: transformationMorph.
	titleStringMorph := StringMorph new.
	titleStringMorph font: self class titleFont.
	transformationMorph addMorph: titleStringMorph.
	transformationMorph rotationDegrees: -90.0.
	titleStringMorph contents: titleString.
	transformationMorph x: 0 y: 10! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 3/1/2006 16:34'!
drawModelMessageOn: aCanvas in: rectangle 
	| message |
	message _ context model hasMessage
				ifTrue: [context model message]
				ifFalse: ['Ctrl-d=detail | Ctrl-b=browse']. 
	aCanvas
		drawString: message
		in: (rectangle insetBy: 3)
		font: self class messageFont
		color: Color gray! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/25/2006 17:17'!
hideDetail
	detailMorph
		ifNil: [^ self].
	self removeMorph: detailMorph.
	detailMorph delete.
	detailMorph _ nil. 
	self changed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/2/2006 21:17'!
toggleDetail
	self itemsCount == 0
		ifTrue: [^ self].
	detailMorph
		ifNil: [self showDetail]
		ifNotNil: [self hideDetail].
! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/5/2004 22:23'!
moveDown
	self selected: self selected + 1.
	(self selected > self lastVisible
			and: [self selected <= self itemsCount])
		ifTrue: [firstVisible := firstVisible + 1].
	self changed! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'bar 3/2/2006 17:37'!
height
	| height |
	height _ self visible
				ifTrue: [Display height - self bounds topLeft y / self class itemHeight - 1 min: self class maxLength]
				ifFalse: [self class maxLength].
	height asInteger isZero
		ifTrue: [^ 1]
		ifFalse: [^ height].! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/13/2004 15:05'!
moveUp
	(self selected = 0
			and: [self firstVisible = 1])
		ifTrue: [^ self].
	self selected: self selected - 1.
	self selected < self firstVisible
		ifTrue: [firstVisible := firstVisible - 1].
	self changed. ! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 10/16/2004 15:12'!
itemHeight

	"CompletionMorph itemHeight "
	
	^ 14.! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 8/12/2005 23:12'!
selectColor: type
	^ self class selectColorFor: type! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:24'!
pageDown
	self gotoPage: self currentPage + 1.
	self changed. ! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/16/2004 11:36'!
expand
	context model toggleExpand.
	self narrowCompletion! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'pk 5/31/2004 11:25'!
selected
	"Answer the value of selected"

	^ selected! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 11:48'!
selected: aNumber 
	"Set the value of selected"

	context model notEmpty 
		ifTrue: 
			[((1 to: self itemsCount) includes: aNumber) ifTrue: [selected := aNumber]]! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 8/12/2005 22:43'!
selectFont: aSymbol 
	^ self class selectFontFor: aSymbol! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 12/17/2004 23:01'!
messageFont
	messageFont _ nil.
	messageFont
		ifNil: [messageFont _ StrikeFont
						familyName: 'Accuny'
						size: 8
						emphasized: 0].
	^ messageFont! !

!ECMenuMorph methodsFor: 'title' stamp: 'bar 12/13/2004 14:16'!
removeTitle
	titleStringMorph
		ifNil: [^ self].
	self removeMorph: titleStringMorph owner. 
	titleStringMorph := nil! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/1/2006 15:25'!
browse
	| entry |
	entry _ context model entries at: selected.
	(entry browseWith: context) ifTrue:
[			controller closeMenu]! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 2/21/2006 21:29'!
gotoPage: anInteger
	| item |
	item _ anInteger - 1 * self pageHeight + 1.
	item >= self itemsCount ifTrue:[^self].
	item < 1 ifTrue:[item _ 1].
	firstVisible _ item.
	self selected: firstVisible. 
	! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 2/20/2006 18:51'!
drawMessageOn: aCanvas in: rectangle 
	self hasMessage ifFalse:[^self].
	context model isEmpty 
		ifFalse:[
			aCanvas
				line: rectangle topLeft + (0 @ 2)
				to: rectangle topRight + (-3 @ 2)
				color: Color gray]. 
	self drawModelMessageOn: aCanvas in:rectangle.
	self drawPageCountMessageOn: aCanvas in: rectangle.! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 11:46'!
firstVisible
	^firstVisible min: context model entryCount! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/13/2004 11:55'!
insertSelected 
	context model isEmpty
		ifTrue: [^ false].
	self
		insertCompletion: (context model completionAt: selected).
	self delete.
	^ true! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 12/17/2004 23:14'!
drawBottomScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	point _ self bounds bottomLeft translateBy: 6 @ -12.
	arrowHeight _ self class scrollArrowSize.
	aPoligon _ Array
				with: point
				with: (point translateBy: arrowHeight @ 0)
				with: (point translateBy: arrowHeight / 2 @ arrowHeight).
	aCanvas drawPolygon: aPoligon fillStyle: self class scrollColor! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/13/2004 15:04'!
insertCompletion: aString 
	| caret old pos editor |
	editor := controller editor.
	caret := editor caret.
	editor selectInvisiblyFrom: caret - context completionToken size to: caret - 1.
	old := editor selection. 
	editor zapSelectionWith: aString.
	pos := caret + (aString copyUpTo: $ ) size + 1 - old size.
	editor selectAt: pos.
	editor morph invalidRect: editor morph bounds! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 17:35'!
show
	| extent height |
	firstVisible _ 1.
	height _ self visibleItemsCount * self class itemHeight.
	pageHeight _ self height asInteger.
	self hasMessage
		ifTrue: [height _ height + self class itemHeight].
	titleStringMorph
		ifNotNil: [height _ height max: titleStringMorph width + 30].
	extent _ self class itemWidth @ height.
	self extent: extent.
	self changed! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 11:47'!
itemsCount
	^context model entryCount! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'bar 11/18/2004 14:10'!
initialize

	super initialize.
	
	self color: self class backgroundColor.
	! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 10/17/2004 15:16'!
itemWidth

	^ 200.! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 11/19/2004 20:53'!
scrollArrowSize
	^8! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 2/20/2006 17:53'!
pageHeight
	^pageHeight.! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 2/25/2006 18:06'!
drawOn: aCanvas 
	| rectangle model |
	super drawOn: aCanvas.
	self drawTitleOn: aCanvas.
	rectangle _ self bounds copy.
	rectangle bottom: rectangle top + self class itemHeight.
	rectangle _ rectangle left: rectangle left + 20.
	model _ context model.
	self extent: self extent.
	self firstVisible > 1
		ifTrue: [self drawTopScrollArrowOn: aCanvas].
	self lastVisible ~= self itemsCount
		ifTrue: [self drawBottomScrollArrowOn: aCanvas].
	model notEmpty
		ifTrue: [self firstVisible
				to: self lastVisible
				do: [:index | 
					| symbol type string | 
					symbol _ model entries at: index.
					string _ symbol contents.
					type _ symbol type.
					index = selected
						ifTrue: [| rect | 
							rect _ rectangle withBottom: rectangle top + self class itemHeight.
							aCanvas fillRectangle: rect color: self class scrollColor.
							self drawDetail: symbol at: rect topRight].
					aCanvas
						drawString: string
						in: (rectangle insetBy: 1)
						font: (self selectFont: type)
						color: (self selectColor: type).
					rectangle _ self prepareRectForNextRow: rectangle]].
	self drawMessageOn: aCanvas in: rectangle! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 2/20/2006 18:31'!
hasMessage
	^ context model hasMessage or:[self pageCount > 1].! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 10/17/2004 15:16'!
maxLength

	"CompletionMorph maxLength "
	
	^30.! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 8/12/2005 22:41'!
selectFontFor: aSymbol 
	| emphasized attributes |
	attributes _ SHTextStylerST80 new
				attributesFor: (self convertToSHSymbol: aSymbol).
	emphasized _ attributes size > 1
				ifTrue: [attributes second emphasisCode]
				ifFalse: [0]. 
	^ StrikeFont
		familyName: 'Accuny'
		size: 12
		emphasized: emphasized! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 10/17/2004 15:15'!
lastVisible

	^ (self firstVisible + self height-1)  min: (self itemsCount).! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 2/20/2006 18:32'!
drawPageCountMessageOn: aCanvas in: rectangle 
	| msg font msgWidth |
	self pageCount > 1 ifFalse:[^self].
	msg _  self currentPage printString, '/', self pageCount printString.
	font _ self class messageFont.
	msgWidth _ font widthOfString: msg.
	aCanvas 
		drawString: msg 
		in: (rectangle translateBy: (rectangle width - msgWidth - 3) @ 3)
		font: font
		color: Color gray. 
		! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 2/26/2006 11:47'!
backgroundColor
	"ECMenuMorph backgroundColor"
	^ Color
		r: 0.95
		g: 0.95
		b: 0.8
		alpha: 0.9! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/20/2004 23:21'!
switchToUntyped
	context switchToUntyped.
	self removeTitle; narrowCompletion; changed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
home
	self gotoPage: 1.
	self changed! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'pk 6/3/2004 00:09'!
scrollColor

	"CompletionMorph scrollColor "

	^ Color r: 1 g: 0.55 b: 0.4 alpha: 0.9.! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 8/12/2005 22:47'!
titleFont
	titleFont _ nil.
	titleFont
		ifNil: [titleFont _ StrikeFont
						familyName: 'Accuny'
						size: 20
						emphasized: 1].
	^ titleFont! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
pageUp
	self gotoPage: self currentPage - 1.
	self changed. ! !

!ECMenuMorph class methodsFor: 'instance creation' stamp: 'bar 12/13/2004 11:34'!
controller: aECController position: aPoint 
	| newObject |
	newObject := self new.
	newObject setController: aECController position: aPoint.
	^ newObject! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/2/2006 21:17'!
showDetail
	detailMorph
		ifNotNil: [^ self].
	detailMorph _ ECDetailMorph new.
	detailMorph hide.
	self addMorph: detailMorph.
	self changed.! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 17:50'!
drawDetail: anECEntry at: aPoint 
	detailMorph
		ifNil: [^ self].
	detailMorph
		entryDescription: (anECEntry descriptionWith: context). 
	detailMorph position: aPoint.
	detailMorph changed.
	detailMorph show! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 8/12/2005 22:37'!
selectColorFor: aSymbol 
	| attribute |
	attribute _ self convertToSHSymbol: aSymbol.
	^ (SHTextStylerST80 new attributesFor: attribute) first color. ! !

!String methodsFor: '*ecompletion' stamp: 'bar 8/4/2005 21:25'!
wordBefore: anIndex
	| sep tok |
	tok _ false.
	sep _ anIndex.
	[sep > 0
		and: [(self at: sep) tokenish]]
		whileTrue: [tok _ true.
			sep _ sep - 1].
	^ tok
		ifTrue: [self copyFrom: sep + 1 to: anIndex]
		ifFalse: [String new]! !

!String methodsFor: '*ecompletion' stamp: 'bar 8/4/2005 21:25'!
beginsWithEmpty: prefix caseSensitive: aBoolean
	"Answer whether the receiver begins with the given prefix string. 
	The comparison is case-sensitive."
	| matchTable |
	prefix isEmpty
		ifTrue: [^ true].
	self size < prefix size
		ifTrue: [^ false].
	 matchTable _ aBoolean
				ifTrue: [CaseSensitiveOrder]
				ifFalse: [CaseInsensitiveOrder].
	^ (self
		findSubstring: prefix
		in: self
		startingAt: 1
		matchTable: matchTable)
		= 1! !

!String methodsFor: '*ecompletion' stamp: 'bar 8/4/2005 21:25'!
indexOfFirstUppercaseCharacter
	| position found input |
	position _ 0.
	found _ false.
	input _ ReadStream on: self.
	[input atEnd | found ] 
		whileFalse:
			[input next isUppercase 
				ifTrue:[ found _ true ]. 
			position _ position + 1].
	found 
		ifTrue:[ ^position ]
		ifFalse:[ ^0 ]
! !

!CodeHolder methodsFor: '*ecompletion-override' stamp: 'bar 12/13/2004 14:39'!
contentsChanged
	super contentsChanged.
	self changed: #annotation.
	self completionController closeMenu! !

!CodeHolder methodsFor: '*ecompletion' stamp: 'bar 11/30/2004 16:10'!
receiverClass
	^ self selectedClassOrMetaClass! !
ECTestClass initialize!
ECTestSuperClass initialize!
ECController initialize!
ECPreferences initialize!
